﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        ToolTips_Init()
        MeterInitialize()
        InitPanels()
        Load_INI()
        ReadPercentilesSet()
        EnsureFileInRawDataFolder(FilePathAndName)
        ShowFileName()
        UpdateAllPanels()
        Refresh()
        Opacity = 1
        SetIsoType()
        SetAutoMax()
        InitFilterParams()
        InitControls()
        InitGraphs()
        GraphPaper1.InitFrequencyBars()
        GraphPaper1.SetHorizontalScale(GraphPaper1.ScaleHorizontal)
        Me.Refresh()
        Application.DoEvents()
        EventsAreEnabled = True
        StartScanning()
        Timer1.Interval = 10
        Timer1.Start()
        ' ------------------------------------------------- this makes SendKeys faster
        SchedulerMaxPrecision()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
        SchedulerDefaultPrecision()
        End
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        If WindowState = FormWindowState.Minimized Then Return
        SplitContainer1.Width = Me.ClientSize.Width - SplitContainer1.Left - 6
        SplitContainer1.Height = Me.ClientSize.Height - SplitContainer1.Top - 6
        GraphPaper1.ResizeEvent()
        GraphPaper1.InitFrequencyBars()
        GraphPaper1.UpdateTimeGraph()
    End Sub

    Private Sub SplitContainer1_SplitterMoved(ByVal sender As System.Object, ByVal e As System.Windows.Forms.SplitterEventArgs) Handles SplitContainer1.SplitterMoved
        If Not EventsAreEnabled Then Return
        UpdateGraphPaper = True
        TextBox_ScrollToFirstLine(TextBox_Reports)
    End Sub

    Private Sub TextBox1_KeyDownUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) _
                                                                                        Handles TextBox_Reports.KeyDown, _
                                                                                                TextBox_Reports.KeyUp
        If e.KeyCode = Keys.Up Or e.KeyCode = Keys.Down Then
            Dim n As Int32 = TextBox_Reports.GetLineFromCharIndex(TextBox_Reports.SelectionStart)
            DecodeDateAndMoveGraphPaper(n)
        End If
    End Sub

    Private Sub TextBox1_SelectionChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox_Reports.Click
        Dim n As Int32 = TextBox_Reports.GetLineFromCharIndex(TextBox_Reports.SelectionStart)
        DecodeDateAndMoveGraphPaper(n)
    End Sub

    Friend Sub TextBox_SetCaretToLine(ByVal tbox As TextBox, ByVal lineindex As Int32)
        If lineindex > tbox.Lines.Length - 1 Then Return
        If lineindex < 0 Then Return
        Dim p1 As Int32 = tbox.GetFirstCharIndexFromLine(lineindex)
        tbox.SelectionStart = p1
        tbox.SelectionLength = 0
        tbox.ScrollToCaret()
    End Sub

    Private Sub TextBox_ScrollToFirstLine(ByVal tbox As TextBox)
        tbox.SelectionStart = 0
        tbox.ScrollToCaret()
    End Sub

    Private Sub TextBox_ScrollToLastLine(ByVal tbox As TextBox)
        tbox.SelectionStart = 999999
        tbox.ScrollToCaret()
    End Sub

    Private Sub GroupBox_Reports_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GroupBox_Reports.Click
        SplitContainer1.SplitterDistance = 9999
        GraphPaper1.UpdateTimeGraph()
    End Sub

    Private Sub GroupBox_TimeGraph_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GroupBox_TimeGraph.Click
        SplitContainer1.SplitterDistance = 0
        GraphPaper1.UpdateTimeGraph()
    End Sub
    Private Sub GroupBox_Reports_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles GroupBox_Reports.DoubleClick
        SplitContainer1.SplitterDistance = SplitContainer1.Height \ 2
        GraphPaper1.UpdateTimeGraph()
    End Sub
    Private Sub GroupBox_TimeGraph_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles GroupBox_TimeGraph.DoubleClick
        SplitContainer1.SplitterDistance = SplitContainer1.Height \ 2
        GraphPaper1.UpdateTimeGraph()
    End Sub

    Private Sub chk_ShowFrequencyGraph_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_ShowFrequencyGraph.CheckedChanged
        If Not EventsAreEnabled Then Return
        InitGraphs()
    End Sub
    Private Sub InitGraphs()
        GraphPaper1.PB_TimeGraph = pbox_TimeGraph
        GraphPaper1.PB_FrequencyGraph = pbox_FrequencyGraph
        pbox_FrequencyGraph.Location = TextBox_Reports.Location
        pbox_FrequencyGraph.Size = TextBox_Reports.Size
        If chk_ShowFrequencyGraph.Checked Then
            pbox_FrequencyGraph.Show()
            GroupBox_Reports.Text = "Frequency Bands"
            TextBox_Reports.Visible = False
            chk_AutoMax.FlatAppearance.CheckedBackColor = chk_ShowFrequencyGraph.FlatAppearance.CheckedBackColor
            chk_AutoMax.Enabled = True
            Chk_AverageSpectrum.Enabled = True
            Chk_Debug.Visible = True
            GraphPaper1.UpdateTimeGraph()
        Else
            pbox_FrequencyGraph.Hide()
            GroupBox_Reports.Text = "Reports"
            TextBox_Reports.Visible = True
            chk_AutoMax.FlatAppearance.CheckedBackColor = chk_AutoMax.BackColor
            chk_AutoMax.Enabled = False
            Chk_AverageSpectrum.Enabled = False
            Chk_Debug.Visible = False
        End If
    End Sub

    Private Sub chk_AutoMax_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_AutoMax.CheckedChanged
        If Not EventsAreEnabled Then Return
        SetAutoMax()
        UpdateGraphPaper = True
    End Sub

    Private Sub SetAutoMax()
        AutoMax = chk_AutoMax.Checked
    End Sub

    Private Sub Chk_AverageSpectrum_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Chk_AverageSpectrum.CheckedChanged
        If Chk_AverageSpectrum.Checked Then
            'CreateMiddleBandValues() '02/03/24
            'Chk_AverageSpectrum.Checked = False
        End If
        GraphPaper1.UpdateTimeGraph()
    End Sub

    Private Sub Txt_Percentiles_levels_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Txt_Percentiles_levels.TextChanged
        If Not EventsAreEnabled Then Return
        ReadPercentilesSet()
    End Sub

    Private Sub Chk_Debug_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Chk_Debug.CheckedChanged
        DebugFrequencyGraph = Chk_Debug.Checked
        GraphPaper1.UpdateTimeGraph()

        Chk_Debug.BackColor = If(Chk_Debug.Checked, Color.GreenYellow, Color.Gainsboro)
    End Sub



    ' =============================================================================================
    '  MenuStrip, ToolStrip and RichTextBox accepting the first click
    '  If the form is not focused and receives a WM_PARENTNOTIFY (528) message
    '  then the form is activated before to exec the message
    ' =============================================================================================
    <DebuggerStepThrough()> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub

    ' ===================================================================================================
    '  FILTERS - PARAMS 
    ' ===================================================================================================
    Private Sub SaveFilterParamsOnLostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                Handles txt_FilterImpulseInc.LostFocus, _
                                                                        txt_FilterImpulseDec.LostFocus, _
                                                                        txt_FilterFastInc.LostFocus, _
                                                                        txt_FilterFastDec.LostFocus, _
                                                                        txt_FilterSlowInc.LostFocus, _
                                                                        txt_FilterSlowDec.LostFocus, _
                                                                        chk_FilterImpulseLinear.LostFocus, _
                                                                        chk_FilterFastLinear.LostFocus, _
                                                                        chk_FilterSlowLinear.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub FilterParams_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                    Handles txt_FilterImpulseInc.TextChanged, _
                                                                            txt_FilterImpulseDec.TextChanged, _
                                                                            txt_FilterFastInc.TextChanged, _
                                                                            txt_FilterFastDec.TextChanged, _
                                                                            txt_FilterSlowInc.TextChanged, _
                                                                            txt_FilterSlowDec.TextChanged, _
                                                                            chk_FilterImpulseLinear.CheckedChanged, _
                                                                            chk_FilterFastLinear.CheckedChanged, _
                                                                            chk_FilterSlowLinear.CheckedChanged
        InitFilterParams()
    End Sub

    Private Sub InitFilterParams()
        TimeConstImpulseInc_Sec = txt_FilterImpulseInc.NumericValueInteger / 1000
        TimeConstFastInc_Sec = txt_FilterFastInc.NumericValueInteger / 1000
        TimeConstSlowInc_Sec = txt_FilterSlowInc.NumericValueInteger / 1000

        TimeConstImpulseDec_Sec = txt_FilterImpulseDec.NumericValueInteger / 1000
        TimeConstFastDec_Sec = txt_FilterFastDec.NumericValueInteger / 1000
        TimeConstSlowDec_Sec = txt_FilterSlowDec.NumericValueInteger / 1000

        FilterImpulseLinear = chk_FilterImpulseLinear.Checked
        FilterFastLinear = chk_FilterFastLinear.Checked
        FilterSlowLinear = chk_FilterSlowLinear.Checked
    End Sub


    ' ===================================================================================================
    '  FILE SELECTED 
    ' ===================================================================================================
    Friend FilePathAndName As String = ""
    Private Sub lbl_FileSelected_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lbl_FileSelected.Click
        Dim ofd As OpenFileDialog = New OpenFileDialog()
        '
        If IO.File.Exists(FilePathAndName) Then
            ofd.InitialDirectory = IO.Path.GetDirectoryName(FilePathAndName)
        Else
            ofd.InitialDirectory = DataFilePath ' GetRawDataFolder()
        End If
        ofd.FileName = IO.Path.GetFileName(FilePathAndName)
        '
        ofd.AutoUpgradeEnabled = True
        ofd.Title = "Open file"
        ofd.ValidateNames = False
        ofd.Multiselect = True
        ofd.Filter = "All files (*.*)|*.*"
        ofd.DefaultExt = ".txt"
        '
        Cursor.Current = Cursors.WaitCursor
        SendKeys.Send("+{TAB}+{TAB}" + ofd.FileName + "{TAB}{TAB}") ' file selected in the list
        'SendKeys.Send("{HOME}{END}^A") ' << name visible and selected
        SendKeys.Send("{HOME}{END}")   ' << name visible and unselected
        Cursor.Current = Cursors.Default
        '
        If ofd.ShowDialog() = Windows.Forms.DialogResult.OK Then
            If IO.Path.GetExtension(ofd.FileName).ToLower = ".txt" Then
                FilePathAndName = ofd.FileName
                EnsureFileInRawDataFolder(FilePathAndName)
                ShowFileName()
                StartScanning()
            End If
        End If
    End Sub

    Private Sub ShowFileName()
        Dim s As String = IO.Path.GetFileNameWithoutExtension(FilePathAndName)
        If s IsNot Nothing AndAlso s.Length > 11 Then
            s = s.Substring(0, 10) + vbCrLf + s.Substring(11)
            lbl_FileSelected.Text = s
        Else
            lbl_FileSelected.Text = ""
        End If
    End Sub

    Private Function EnsureFileInRawDataFolder(ByRef filename As String) As Boolean
        If Not filename.StartsWith(DataFilePath) Then
            filename = ""
        End If
    End Function

    ' ===================================================================================================
    '  MIN MAX DB - PARAMS 
    ' ===================================================================================================
    Private Sub SaveParamsOnLostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                Handles txt_PeriodsCount.LostFocus, _
                                                                        txt_DayStart.LostFocus, _
                                                                        txt_NightStart.LostFocus, _
                                                                        txt_ReportsInterval.LostFocus, _
                                                                        txt_LAeqInterval.LostFocus, _
                                                                        txt_PercentileInterval.LostFocus, _
                                                                        txt_SpecMaxDb.LostFocus, _
                                                                        txt_SpecMinDb.LostFocus, _
                                                                        txt_TC_MinTimeFor.LostFocus, _
                                                                        txt_TC_MaxTimeWithout.LostFocus, _
                                                                        txt_SubtractOutliersCoeff.LostFocus, _
                                                                        txt_SelMaxSeconds.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub Controls_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                    Handles txt_PeriodsCount.TextChanged, _
                                                                            txt_DayStart.TextChanged, _
                                                                            txt_NightStart.TextChanged, _
                                                                            txt_ReportsInterval.TextChanged, _
                                                                            txt_LAeqInterval.TextChanged, _
                                                                            txt_PercentileInterval.TextChanged, _
                                                                            txt_SpecMinDb.TextChanged, _
                                                                            txt_SpecMaxDb.TextChanged, _
                                                                            txt_TC_MinTimeFor.TextChanged, _
                                                                            txt_TC_MaxTimeWithout.TextChanged, _
                                                                            txt_SubtractOutliersCoeff.TextChanged, _
                                                                            txt_SelMaxSeconds.TextChanged, _
                                                                            chk_RoundDisplayFreq.CheckedChanged
        If Not EventsAreEnabled Then Return
        InitControls()
        GraphPaper1.UpdateTimeGraph()
        pbox_TimeGraph.Refresh()
    End Sub

    Private Sub InitControls()
        PeriodsCount = txt_PeriodsCount.NumericValueInteger
        StartDayPeriod = HoursAndMinutesToSingle(txt_DayStart.Text)
        StartNightPeriod = HoursAndMinutesToSingle(txt_NightStart.Text)
        ReportsInterval = txt_ReportsInterval.NumericValueInteger
        LAeqInterval = txt_LAeqInterval.NumericValueInteger
        PercentileInterval = txt_PercentileInterval.NumericValueInteger
        ScaleMax_dB = CInt(txt_SpecMaxDb.NumericValue)
        ScaleMin_dB = CInt(txt_SpecMinDb.NumericValue)
        TC_MinTimeForStationary_Sec = txt_TC_MinTimeFor.NumericValueInteger
        TC_MaxTimeWithoutCT_Sec = txt_TC_MaxTimeWithout.NumericValueInteger
        LAeqSubtractedOutliers_Coefficient = txt_SubtractOutliersCoeff.NumericValueInteger
        SEL_MaxSeconds = txt_SelMaxSeconds.NumericValueInteger
        RoundDisplayFreq = chk_RoundDisplayFreq.Checked
    End Sub

    Friend Function HoursAndMinutesToSingle(ByVal HoursMinutesString As String) As Single
        Dim s() As String = HoursMinutesString.Split(":"c)
        Select Case s.Length
            Case 2
                Return CSng(Val(s(0).Trim.Replace(",", "."))) + CInt(Val(s(1).Trim)) / 60.0F
            Case 1
                Return CSng(Val(s(0).Trim.Replace(",", ".")))
            Case Else
                Return 0
        End Select
    End Function

    Private Sub btn_IsoType_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_IsoType.Click
        LoudnessType = CType((LoudnessType + 1) Mod 2, LoudnessTypes)
        SetIsoType()
        GraphPaper1.UpdateTimeGraph()
    End Sub

    Private Sub SetIsoType()
        btn_IsoType.Text = GetLoudnessName()
    End Sub

    ' =============================================================================================
    '  COMMANDS
    ' =============================================================================================
    Private Sub btn_OpenFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_OpenFolder.Click
        OpenFolder()
    End Sub
    Private Sub btn_OpenFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_OpenFile.Click
        OpenTextFile()
    End Sub
    Private Sub btn_SaveConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SaveConfig.Click
        SaveConfigurationAs()
    End Sub
    Private Sub btn_LoadConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_LoadConfig.Click
        LoadConfiguration()
    End Sub

    Private Sub chk_ScanPeriod_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_ScanPeriod.CheckedChanged
        If Not EventsAreEnabled Then Return
        If chk_ScanPeriod.Checked Then
            StartScanning()
        Else
            ScanEnabled = False
            chk_ScanPeriod.Text = "SCAN PERIOD"
        End If
    End Sub

    ' =============================================================================================
    '  FUNCTIONS
    ' =============================================================================================
    Private Sub StartScanning()
        InitDayEveningNightString()
        PeriodsCounter = 0
        ScanEnabled = True
        EventsAreEnabled = False
        chk_ScanPeriod.Checked = True
        EventsAreEnabled = True
        chk_ScanPeriod.Text = "SCANNING - CLICK TO STOP"
        DisableControls()
        GraphPaper1.ClearGraphs()
        InitFileAndScanPeriod()
        EnableControls()
        GraphPaper1.InitFrequencyBars()
        GraphPaper1.UpdateTimeGraph()
        TextBox_Reports.Focus()
    End Sub

    Private Sub DisableControls()
        GroupBox1.Enabled = False
        GroupBox2.Enabled = False
        GroupBox3.Enabled = False
        GroupBox4.Enabled = False
        GroupBox5.Enabled = False
        GroupBox6.Enabled = False
    End Sub

    Private Sub EnableControls()
        GroupBox1.Enabled = True
        GroupBox2.Enabled = True
        GroupBox3.Enabled = True
        GroupBox4.Enabled = True
        GroupBox5.Enabled = True
        GroupBox6.Enabled = True
    End Sub

    Friend Sub UpdateUserInterface()
        TextBox_ScrollToLastLine(TextBox_Reports)
        Application.DoEvents()
    End Sub

    Friend Function GetLastVisibleLine(ByVal rtb As RichTextBox) As Int32
        Return rtb.GetLineFromCharIndex(rtb.GetCharIndexFromPosition(New Point(1, Me.ClientSize.Height - 8)))
    End Function

    Friend Function GetSiteString() As String
        Dim s As String
        s = FilePathAndName
        s = IO.Path.GetFileNameWithoutExtension(s)
        Dim n As Int32 = s.LastIndexOf("_") + 1
        s = s.Substring(n)
        Return s
    End Function

    ' TODO --------------- NOV 2023 - TEST IF POSSIBLE REMOVE THIS
    ' =====================================================================================
    '  On some computers the MouseWheel does not works on the control pointed by the mouse
    '  So these functions set the focus to controls when mouse enters on the control area
    ' =====================================================================================
    'Private Sub txt_DataList_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox_Reports.MouseEnter
    '    TextBox_Reports.Focus()
    'End Sub
    'Private Sub pbox_TimeGraph_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles pbox_TimeGraph.MouseEnter
    '    pbox_TimeGraph.Focus()
    'End Sub

    Private Sub TextBox_Reports_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TextBox_Reports.MouseWheel
        TextBox_Reports.Focus()
    End Sub
    Private Sub pbox_TimeGraph_MouseWheel_ForFocus(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_TimeGraph.MouseWheel
        pbox_TimeGraph.Focus()
    End Sub

    ' =====================================================================================
    '  Set Zoom with the Mouse Wheel
    ' =====================================================================================
    Private Sub pbox_TimeGraph_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_TimeGraph.MouseWheel
        GraphPaper1.UpdateScalesWithMouseWheel(e.X, e.Y, CorrectMicrometricMouse(e.Delta))
        UpdateGraphPaper = True
    End Sub
    Friend Function CorrectMicrometricMouse(ByVal Delta As Int32) As Int32
        Static sum As Int32 = 0
        sum += Delta
        If Math.Abs(sum) < 120 Then Return 0
        CorrectMicrometricMouse = sum \ 120
        sum = 0
    End Function


    ' ====================================================================================================
    '  Set DeltaSamples with MouseDown and MouseMove on the pbox_TimeGraph
    ' ====================================================================================================
    Private oldx As Int32
    Private oldy As Int32
    Private startx As Int32
    Private starty As Int32
    Private LeftButtonPressed As Boolean
    Private Sub pbox_Paper_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
                                                                                Handles pbox_TimeGraph.MouseDown
        If e.Button = MouseButtons.Left Then
            startx = e.X
            starty = e.Y
            oldx = e.X
            oldy = e.Y
            LeftButtonPressed = True
        End If
    End Sub
    Private Sub pbox_Paper_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
                                                                                Handles pbox_TimeGraph.MouseMove
        If e.Button = MouseButtons.Left Then
            If LeftButtonPressed Then
                Dim deltaX As Int32 = e.X - oldx
                Dim deltaY As Int32 = e.Y - oldy
                If My.Computer.Keyboard.ShiftKeyDown Then deltaX *= 100
                If My.Computer.Keyboard.CtrlKeyDown Then deltaX *= 10
                GraphPaper1.UpdateWithMousePressed(deltaX, deltaY, startx, starty)
                oldx = e.X
                oldy = e.Y
                UpdateGraphPaper = True
            End If
        End If
    End Sub
    Private Sub pbox_Paper_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) _
                                                                                Handles pbox_TimeGraph.MouseUp
        LeftButtonPressed = False
    End Sub

    ' ====================================================================================================
    '  FrequencyGraph SelectBand and TestBand
    ' ====================================================================================================
    Private Sub pbox_FrequencyGraph_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_FrequencyGraph.MouseDown
        chk_AutoMax.Checked = False
        GraphPaper1.SelectBand(e.X)
    End Sub
    Private Sub pbox_FrequencyGraph_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_FrequencyGraph.MouseMove
        GraphPaper1.TestBand(e.X)
    End Sub
    Private Sub pbox_FrequencyGraph_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles pbox_FrequencyGraph.MouseLeave
        GraphPaper1.TestBand(-1)
    End Sub



    ' =====================================================================================
    '  UPDATE TIMER for TIME GRAPH and REPORTS
    ' =====================================================================================
    Private sw As Stopwatch
    Private UpdateGraphPaper As Boolean
    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' --------------------------------------- init stopwatch
        If sw Is Nothing Then
            sw = New Stopwatch
            sw.Start()
        End If
        ' --------------------------------------- read and show the last line
        ReadLastLine()
        If ScanEnabled Then
            chk_ScanPeriod.Text = "SCANNING " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf + "( Click or ESC to stop )"
        End If
        '
        If UpdateGraphPaper Then
            UpdateGraphPaper = False
            GraphPaper1.UpdateTimeGraph()
        End If
        ' --------------------------------------- update short report
        Static working As Boolean = False
        If Not working Then
            working = True
            Dim secs As Int32 = ReportsInterval * 60
            If secs < 5 Then secs = 5
            If sw.Elapsed.TotalSeconds >= secs Then
                sw.Reset()
                sw.Start()
                PrintPeriodicReport(ReportTypes.ShortReport)
                SavePeriodicImage()
            End If
            working = False
        End If
        ' --------------------------------------- test for the "next day" file
        TestForNextDay()
    End Sub

    Private Sub SavePeriodicImage()
        Dim fname As String = ReportsPath + "\" + GetSiteString() + "_Noise.jpg"
        SaveImage_ByPathAndControl(fname, SplitContainer1)
        ' ------------------------------------------------  IMAGE TO FTP
        SendShortReportImage_FromLocalFileToFTP(fname)
    End Sub

    Friend Sub SaveReportText(ByVal reportType As ReportTypes)
        Dim fname As String
        If reportType = ReportTypes.EndOfDay_H22 Then
            fname = ReportsPath + "\" + GetSiteString() + "_NoiseDay_" + RowDateTime.ToString("yyyy_MM_dd") + ".txt"
            'Else '18/02/2024
            '    fname = ReportsPath + "\" + GetSiteString() + "_NoiseNight_" + RowDateTime.Subtract(New TimeSpan(1, 0, 0, 0)).ToString("yyyy_MM_dd") + ".txt" '18/02/2024
        ElseIf reportType = ReportTypes.EndOfNight_H06 Then '18/02/2024
            fname = ReportsPath + "\" + GetSiteString() + "_NoiseNight_" + RowDateTime.Subtract(New TimeSpan(1, 0, 0, 0)).ToString("yyyy_MM_dd") + ".txt" '18/02/2024
        Else '18/02/2024
            fname = ReportsPath + "\" + GetSiteString() + "_Immediate_" + RowDateTime.ToString("yyyy_MM_dd_hh_mm_ss") + ".txt" '18/02/2024

        End If
        Dim txt As String = TextBox_Reports.Text
        Dim writer As System.IO.StreamWriter
        writer = New System.IO.StreamWriter(fname)
        writer.Write(txt)
        writer.Close()
        ' ------------------------------------------------ REPORT FILE TO FTP
        SendPeriodicReport_FromLocalFileToFTP(fname)
    End Sub


    ' ===================================================================================================
    '  PANELS 
    ' ===================================================================================================
    Private PanelHeight(6) As Int32

    Private Sub InitPanels()
        PanelHeight(1) = GroupBox1.Height
        PanelHeight(2) = GroupBox2.Height
        PanelHeight(3) = GroupBox3.Height
        PanelHeight(4) = GroupBox4.Height
        PanelHeight(5) = GroupBox5.Height
        PanelHeight(6) = GroupBox6.Height
    End Sub

    Private Sub GroupBox_Click(ByVal sender As Object, ByVal e As EventArgs) Handles GroupBox1.Click, _
                                                                                     GroupBox2.Click, _
                                                                                     GroupBox3.Click, _
                                                                                     GroupBox4.Click, _
                                                                                     GroupBox5.Click, _
                                                                                     GroupBox6.Click
        Dim gbox As GroupBox = CType(sender, GroupBox)
        If gbox.PointToClient(MousePosition).Y > 20 Then Return
        ToggleGboxHeight(gbox)
        UpdateAllPanels()
    End Sub

    Private Sub ToggleGboxHeight(ByVal gbox As GroupBox)
        Dim i As Int32 = CInt(Val(gbox.Name.Substring(gbox.Name.Length - 1)))
        If gbox.Height > 20 Then
            gbox.Height = 16
        Else
            gbox.Height = PanelHeight(i)
        End If
    End Sub

    Private Sub SetGboxHeight(ByVal gbox As GroupBox)
        Dim i As Int32 = CInt(Val(gbox.Name.Substring(gbox.Name.Length - 1)))
        If gbox.Height <= 20 Then
            gbox.Height = 16
        Else
            gbox.Height = PanelHeight(i)
        End If
    End Sub

    Private Sub UpdateAllPanels()
        ' --------------------------------------- Use this method if some GBOX is not located on the form
        GroupBox4.Parent = Me
        GroupBox4.Left = GroupBox1.Left
        GroupBox5.Parent = Me
        GroupBox5.Left = GroupBox1.Left
        GroupBox6.Parent = Me
        GroupBox6.Left = GroupBox1.Left
        ' --------------------------------------- Ensure the correct height also if INI is not ok
        SetGboxHeight(GroupBox1)
        SetGboxHeight(GroupBox2)
        SetGboxHeight(GroupBox3)
        SetGboxHeight(GroupBox4)
        SetGboxHeight(GroupBox5)
        SetGboxHeight(GroupBox6)
        ' --------------------------------------- Set the vertical positions
        GroupBox2.Top = GroupBox1.Bottom + 6
        GroupBox3.Top = GroupBox2.Bottom + 6
        GroupBox4.Top = GroupBox3.Bottom + 6
        GroupBox5.Top = GroupBox4.Bottom + 6
        GroupBox6.Top = GroupBox5.Bottom + 6
        chk_ScanPeriod.Top = GroupBox6.Bottom + 6
        ' --------------------------------------- Set the Form minimum height
        Dim topSize As Int32 = Me.Size.Height - Me.ClientSize.Height
        Dim MinHeight As Int32 = chk_ScanPeriod.Bottom + topSize + 8
        If MinHeight < 480 Then MinHeight = 480
        Me.MinimumSize = New Size(Me.MinimumSize.Width, MinHeight)
    End Sub

    ' ===================================================================================================
    '  SEND MAIL IF LAeq PARTIAL IS MORE THAN LIMIT
    ' ===================================================================================================
    Friend Sub TestSendMail(ByVal LAeq As Double, _
                            ByVal TestSite As String)

        Dim subject As String = "ALERT " + TestSite + " Noise"

        Dim body As String = RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + _
                               " LAeq = " & LAeq.ToString("0.0", GCI) + " > " + _
                               txt_SendMails_MaxLAeq.Text

        If LAeq >= txt_SendMails_MaxLAeq.NumericValue Then
            SendMail(txt_SendMail_Destinations.Text, _
                     "", _
                     "", _
                     txt_SendMail_Sender.Text, _
                     txt_SendMail_Sender.Text, _
                     txt_SendMail_Sender.Text, _
                     subject, _
                     "", _
                     body, _
                     False, _
                     False, _
                     txt_SendMail_SMTP.Text, _
                     txt_SendMail_Sender.Text, _
                     txt_SendMail_Password.Text, _
                     "25", _
                     "587", _
                     chk_SendMail_Encripted.Checked, _
                     True)
        End If
    End Sub

    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 700
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_PeriodsCount, _
                        " Periods count" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The number of periods that should be reported." & vbCrLf & _
                        " After reported this number of periods the following days are not loaded." & vbCrLf & vbCrLf & _
                        " Set this count to ""0"" to disable the ""Next Day"" searching." & vbCrLf & _
                        " With ""0"" you can load a complete day and explore decibels and frequency data." & vbCrLf & _
                        " Set to ""999"" to carry out the processing continue.")

        ttp1.SetToolTip(txt_SelMaxSeconds, _
                        " Sel Max Seconds" & vbCrLf & _
                        " - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" & vbCrLf & _
                        " The max number of seconds for event recognition and SEL calculation." & vbCrLf & vbCrLf & _
                        " By setting the time in seconds in the SEL box" & vbCrLf & _
                        " you set the duration beyond which a sound phenomenon" & vbCrLf & _
                        " is not recognized as an event for the purposes" & vbCrLf & _
                        " of calculating the SEL. If you want to exclude" & vbCrLf & _
                        " the calculation and display of the SEL," & vbCrLf & _
                        " set 0 in the box.")

    End Sub

    Private Sub Chk_Immediate_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Chk_Immediate.CheckedChanged
        PrintPeriodicReport(ReportTypes.Immediate)
        Chk_Immediate.Checked = False
    End Sub

End Class
