﻿Imports System.Math
Module Module_MeterFunctions

    Private MaxHours As Int32 = 30

    Friend StartDayPeriod As Single = 6
    Friend StartNightPeriod As Single = 22

    Friend StringStartOfDayPeriod_H06 As String = "06:00:00"
    Friend StringStartOfEveningPeriod_H20 As String = "20:00:00"
    Friend StringStartOfNightPeriod_H22 As String = "22:00:00"
    Friend StartOfDayPeriod_H06 As Single = HoursAndMinutesAndSecondsToSingle(StringStartOfDayPeriod_H06)
    Friend StartOfEveningPeriod_H20 As Single = HoursAndMinutesAndSecondsToSingle(StringStartOfEveningPeriod_H20)
    Friend StartOfNightPeriod_H22 As Single = HoursAndMinutesAndSecondsToSingle(StringStartOfNightPeriod_H22) 
    Private Day_hourly_impulses_for_impulsivity As Int32 = 10
    Private Night_hourly_impulses_for_impulsivity As Int32 = 2

    Friend TimeConstPeakInc_Sec As Double = 0.0
    Friend TimeConstPeakDec_Sec As Double = 0.00002
    '------------------------------------------------------------- RED
    Friend TimeConstImpulseInc_Sec As Double = 0.001 '0.035
    Friend TimeConstImpulseDec_Sec As Double = 1.5
    ' ------------------------------------------------------------ BLUE
    Friend TimeConstFastInc_Sec As Double = 0.05 '0.035  '0.001
    Friend TimeConstFastDec_Sec As Double = 0.125
    ' ------------------------------------------------------------ GREEN
    Friend TimeConstSlowInc_Sec As Double = 0.08  '0.001
    Friend TimeConstSlowDec_Sec As Double = 1.0

    Friend FilterImpulseLinear As Boolean
    Friend FilterFastLinear As Boolean
    Friend FilterSlowLinear As Boolean

    Private Octaves() As Single = {31.5, 63, 125, 250, 500, 1000, 2000, 4000, 8000, 16000, 0, 0, 0, 0, 0}

    Private ThirdsOctaves() As Single = {10, 12.5, 16, 20, 25, 31.5, 40, 50, 63, 80, _
                                         100, 125, 160, 200, 250, 315, 400, 500, 630, 800, _
                                         1000, 1250, 1600, 2000, 2500, 3150, 4000, 5000, 6300, 8000, _
                                         10000, 12500, 16000, 20000, 25000, 0, 0, 0, 0, 0}

    Private PonderationA() As Single = {-70.4, -63.4, -56.7, -50.5, -44.7, -39.4, -34.6, -30.2, -26.2, -22.5, _
                                        -19.1, -16.1, -13.4, -10.9, -8.6, -6.6, -4.8, -3.2, -1.9, -0.8, _
                                        0.0, 0.6, 1.0, 1.2, 1.3, 1.2, 1.0, 0.5, -0.1, -1.1, _
                                        -2.5, -4.3, -6.6, -9.3, -12.0, 0.0, 0.0, 0.0, 0.0, 0.0}
    Private DayNightString As String
    Private DayEveningNightString As String

    Friend LoadedLines(-1) As String
    Private LoadedNumLines As Int32 = 0

    Friend RowTimeMS As Int32

    Friend Array_Raw(-1) As Double
    Friend Array_Interp(-1) As Double

    Friend Array_PondZ(-1) As Double
    Friend Array_PondC(-1) As Double
    Friend Array_PondB(-1) As Double
    Friend Array_PondA(-1) As Double
    Friend Array_BandFreq(-1) As Double

    Friend Filters_PeakC(-1) As Filter
    Friend Filters_ImpulseA(-1) As Filter
    Friend Filters_FastA(-1) As Filter
    Friend Filters_SlowA(-1) As Filter
    Friend Filters_FastZ(-1) As Filter

    Friend Array_PeakC(-1) As Double
    Friend Array_ImpulseA(-1) As Double
    Friend Array_FastA(-1) As Double
    Friend Array_SlowA(-1) As Double

    Friend Array_FastZ(-1) As Double

    Private Row_LCP As Double
    Private Row_LAI As Double
    Private Row_LAF As Double
    Private Row_LAS As Double

    Private FileDate As DateTime
    Friend RowDateTime As DateTime
    Friend NumBands As Int32 = 31
    Friend MinFreq As Single
    Friend MaxFreq As Single
    Friend LogScale As Boolean
    Private TestSite As String

    Friend PeriodsCount As Int32
    Friend PeriodsCounter As Int32

    Friend ReportsInterval As Int32
    Friend LAeqInterval As Int32
    Friend PercentileInterval As Int32

    Friend RoundDisplayFreq As Boolean

    Friend LAeqProgressive As Double
    Friend LAeqDen As Double
    Friend SumLAF As Double

    Friend SumLAFday As Double
    Friend SumLAFEvening As Double
    Friend SumLAFNight As Double
    Friend SumLAFden As Double

    Friend LAeqProgressiveCounter As Int32
    Friend LAeqDayCounter As Int32
    Friend LAeqEveningCounter As Int32
    Friend LAeqNightCounter As Int32
    Friend LAeqDenCounter As Int32

    Private LAeqPartialString As String
    Private LAeqTotalString As String
    Private LAeqDenTotalString As String
    Private PercentilePartialString As String
    Private PercentileTotalString As String

    Private LAeqPartial_MinutesCounter As Int32
    Private LAeqTotal_MinutesCounter As Int32
    Private LAeqDenTotal_MinutesCounter As Int32

    Private PercentilePartial_MinutesCounter As Int32
    Private PercentileTotal_MinutesCounter As Int32
    Private PercentilePartialRowCounter As Int32
    Private PercentileTotalRowCounter As Int32
    Private PercentilePartialArray(-1) As Double
    Private PercentileTotalArray(-1) As Double

    Friend LMaxPeakC As Double
    Friend Lday As Double
    Friend Levening As Double
    Friend Lnight As Double
    Friend Lden As Double


    Public Function HoursAndMinutesAndSecondsToSingle(ByVal HoursMinutesSecondsMillisecondsString As String) As Single
        Dim s() As String = HoursMinutesSecondsMillisecondsString.Split(":"c)
        Select Case s.Length
            Case 3
                Return CSng(Val(s(0).Trim.Replace(",", "."))) + CInt(Val(s(1).Trim)) / 60.0F + CInt(Val(s(2).Trim)) / 3600.0F
            Case 2
                Return CSng(Val(s(1).Trim.Replace(",", "."))) + CInt(Val(s(1).Trim)) / 60.0F
            Case 1
                Return CSng(Val(s(0).Trim.Replace(",", ".")))
            Case Else
                Return 0
        End Select
    End Function

    Private Sub DimAllArrays()
        ReDim Array_Raw(NumBands - 1)
        ReDim Array_Interp(NumBands - 1)

        ReDim Array_PondZ(NumBands - 1)
        ReDim Array_PondC(NumBands - 1)
        ReDim Array_PondB(NumBands - 1)
        ReDim Array_PondA(NumBands - 1)
        ReDim Array_BandFreq(NumBands - 1)

        ReDim Filters_PeakC(NumBands - 1)
        ReDim Filters_ImpulseA(NumBands - 1)
        ReDim Filters_FastA(NumBands - 1)
        ReDim Filters_SlowA(NumBands - 1)
        ReDim Filters_FastZ(NumBands - 1)

        ReDim Array_PeakC(NumBands - 1)
        ReDim Array_ImpulseA(NumBands - 1)
        ReDim Array_FastA(NumBands - 1)
        ReDim Array_SlowA(NumBands - 1)
        ReDim Array_FastZ(NumBands - 1)

        For i As Int32 = 0 To NumBands - 1
            Filters_PeakC(i) = New Filter(RowTimeMS, TimeConstPeakInc_Sec, TimeConstPeakDec_Sec)
            Filters_ImpulseA(i) = New Filter(RowTimeMS, TimeConstImpulseInc_Sec, TimeConstImpulseDec_Sec)
            Filters_FastA(i) = New Filter(RowTimeMS, TimeConstFastInc_Sec, TimeConstFastDec_Sec)
            Filters_SlowA(i) = New Filter(RowTimeMS, TimeConstSlowInc_Sec, TimeConstSlowDec_Sec)
            Filters_FastZ(i) = New Filter(RowTimeMS, TimeConstFastInc_Sec, TimeConstFastDec_Sec)

            Filters_PeakC(i).LinearMode = False
            Filters_ImpulseA(i).LinearMode = FilterImpulseLinear
            Filters_FastA(i).LinearMode = FilterFastLinear
            Filters_SlowA(i).LinearMode = FilterSlowLinear
            Filters_FastZ(i).LinearMode = FilterFastLinear
        Next
    End Sub

    Friend Sub MeterInitialize()
        InitAndCreateFolders()
    End Sub

    ' ===================================================================================
    '  This function creates the "Theremino_Files" folder outside the application folder
    '  The folder is created one or two levels UP, starting from the exe folder
    '  depending if the app has the sources or not
    ' -----------------------------------------------------------------------------------
    '  The final folder structure is:
    '    Theremino_Phonometer
    '       Theremino_AudioElaboration
    '       Theremino_AudioMeter
    '       Theremino_Files
    ' -----------------------------------------------------------------------------------
    Friend DataFilePath As String
    Friend ReportsPath As String
    '
    Private Sub InitAndCreateFolders()
        Dim path As String = Application.StartupPath
        path = IO.Directory.GetParent(path).ToString
        If path.Contains(My.Application.Info.AssemblyName) Then
            path = IO.Directory.GetParent(path).ToString
        End If
        DataFilePath = path + "\Theremino_Files\RawData"
        IO.Directory.CreateDirectory(DataFilePath)
        ReportsPath = path + "\Theremino_Files\Reports"
        IO.Directory.CreateDirectory(ReportsPath)
    End Sub
    ' ===================================================================================

    ' ---------------------------------------------------------------------------------
    '  START PERIOD ANALISYS
    ' ---------------------------------------------------------------------------------
    Private fname As String

    Friend Sub InitFileAndScanPeriod()
        ' -----------------------------------------------------------------------------
        PrepareFileName()
        If Not ValidFileName() Then Return
        OpenInputFile()
        ScanPeriod(True)
        'CloseInputFile()
    End Sub

    Friend Sub OpenFolder()
        Process.Start(IO.Path.GetDirectoryName(fname))
    End Sub

    Friend Sub OpenTextFile()
        PrepareFileName()
        If Not ValidFileName() Then Return
        Process.Start(fname)
    End Sub


    ' ---------------------------------------------------------------------------------
    '   INPUT-FILE - PREPARE FILE-NAME / OPEN / CLOSE 
    ' ---------------------------------------------------------------------------------
    Private m_FileStream As IO.FileStream
    Private m_Streamreader As IO.StreamReader

    Private Sub PrepareFileName()
        fname = Form1.FilePathAndName
    End Sub

    Private Function ValidFileName() As Boolean
        If My.Computer.FileSystem.FileExists(fname) Then
            Return True
        Else
            Form1.TextBox_Reports.Text = vbCrLf + vbCrLf + "  FILE NOT FOUND"
            Form1.TextBox_Reports.Refresh()
            DataArray1 = Nothing
            Return False
        End If
    End Function

    Private InputFileIsOpen As Boolean = False

    Private Sub OpenInputFile()
        'TODO ------------------------------------
        SetToZeroSumBandsValues()
        CounterValue = 0 '02/03/2024
        LMaxPeakC = 0

        CloseInputFile()

        m_FileStream = IO.File.Open(fname, _
                                    IO.FileMode.Open, _
                                    IO.FileAccess.Read, _
                                    IO.FileShare.ReadWrite Or IO.FileShare.Delete)

        m_Streamreader = New IO.StreamReader(m_FileStream, _
                                             System.Text.Encoding.ASCII)

        InputFileIsOpen = True
    End Sub

    Private Sub CloseInputFile()
        InputFileIsOpen = False
        If m_Streamreader IsNot Nothing Then
            m_Streamreader.Close()
        End If
        If m_FileStream IsNot Nothing Then
            m_FileStream.Close()
        End If
    End Sub

    Friend Function GetFileRow(ByVal ix As Int32) As String
        If ix > LoadedNumLines - 1 Then Return ""
        Return LoadedLines(ix)
    End Function

    ' =================================================================================
    '   TEST FOR NEXT DAY
    ' =================================================================================
    Friend Sub TestForNextDay()
        ' ------------------------------------------------------- if not reading a file then exit
        If Not InputFileIsOpen Then Return
        If m_Streamreader Is Nothing Then Return
        '
        ' ------------------------------------------------------- change file only if this is an old file (not today)
        If RowDateTime.Date = Now.Date Then
            Return
        End If
        ' ------------------------------------------------------- change file only if this file is complete
        If Not m_Streamreader.EndOfStream Then
            Return
        End If

        Dim Today As DateTime = RowDateTime
        Dim NextDay As DateTime = Today

        Do
            ' ------------------------------------------------------- create the "NextDay" date
            If Elab_OffLine() Then
                NextDay = NextDay.AddDays(1)
            Else
                NextDay = Today.AddDays(1)
            End If
            ' ------------------------------------------------------- EXIT if next day is > NOW or pressed ESCAPE
            If NextDay > Now.AddDays(1) Or Key(Keys.Escape) Then
                CloseInputFile()
                Form1.chk_ScanPeriod.Checked = False
                Form1.chk_ScanPeriod.Refresh()
                Exit Do
            End If
            ' ------------------------------------------------------- EXIT if mouse-click on the Button-SCANNING
            If Key(Keys.LButton) Then
                If Form1.chk_ScanPeriod.ClientRectangle.Contains(Form1.chk_ScanPeriod.PointToClient(Cursor.Position)) Then
                    CloseInputFile()
                    Form1.chk_ScanPeriod.Checked = False
                    Form1.chk_ScanPeriod.Refresh()
                    Exit Do
                End If
            End If

            ' ------------------------------------------------------- update info on the button
            If ScanEnabled Then
                Form1.chk_ScanPeriod.Text = "NEXT DAY " + NextDay.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf + "( Click or ESC to stop )"
                Form1.chk_ScanPeriod.Refresh()
            End If
            ' ------------------------------------------------------- test the periods counter     
            If PeriodsCounter >= PeriodsCount Then
                CloseInputFile()
                Return
            End If
            ' ------------------------------------------------------- test if the tomorrow file exists
            Dim folderName As String = IO.Path.GetDirectoryName(Form1.FilePathAndName)
            Dim fileName As String = IO.Path.GetFileName(Form1.FilePathAndName)
            Dim f As String = NextDay.ToString("yyyy-MM-dd") + fileName.Substring(10)
            Dim g As String = Today.ToString("yyyy-MM-dd") + fileName.Substring(10)
            f = folderName + "\" + f
            g = folderName + "\" + g
            If My.Computer.FileSystem.FileExists(f) Then
                CloseInputFile()
                fname = f
                OpenInputFile()
                ScanPeriod(False)
                Exit Do
            End If

        Loop

    End Sub

    ' TODO ------------------------------------------------- Pursuit 24
    Friend Function Elab_OffLine() As Boolean
        'if TRUE can skip days but can't pass midnight when work on real time 
        'if FALSE pass midnight when work on real time but can't skip days 
        'if the function return True at starting elaboration, it switch to False 
        'if the most recently file is today's file so it can synchronize with the 
        'scanning process and pass midnight.
        If RowDateTime.Date < Now.Date Then
            If Now.TimeOfDay > New TimeSpan(23, 59, 55) Or _
               Now.TimeOfDay < New TimeSpan(0, 0, 5) Then
                Threading.Thread.Sleep(300)
            End If
            Return True
        Else
            Return False
        End If
    End Function

    ' =================================================================================
    '   ANALISYS
    ' =================================================================================
    Private sa() As String
    Private EnableReport As Boolean

    Private Sub ScanPeriod(ByVal ReinitArrays As Boolean)
        ' ---------------------------------------------------------- extract data from file name and first row
        sa = IO.Path.GetFileNameWithoutExtension(fname).Split("_"c)
        FileDate = ParseFileDateFromString(sa(0))
        NumBands = CInt(Val(sa(1)))
        MinFreq = CSng(Val(sa(2)))
        MaxFreq = CSng(Val(sa(3)))
        LogScale = sa(4).ToLower = "log"
        RowTimeMS = CInt(Val(sa(5)))
        TestSite = sa(6).Replace(".txt", "")
        ReadFirstRowDateTimeFromFile()
        ' ---------------------------------------------------------- reinit all
        If ReinitArrays Then ReinitAllArrays()
        ' ---------------------------------------------------------- read and analyze all file lines
        ReadAllFileLines()
        ' ---------------------------------------------------------- print final report
        EnableReport = True
        PrintPeriodicReport(ReportTypes.EndOfFastLoad)
        ' ---------------------------------------------------------- update time graph
        GraphPaper1.UpdateTimeGraph()
    End Sub


    Private Sub ReinitAllArrays()
        ' ---------------------------------------------------------- redim GraphPaper DataArray for MaxHours 
        RedimDataArrayMax((MaxHours * 3600 * 1000) \ RowTimeMS)
        DataArray1.Flush()
        DataArray1.FillWithInvalidData()
        ' ---------------------------------------------------------- initializations
        DimAllArrays()
        ResetAllCounters()
        DayNight_Init()
        Find_ImpulsiveComponents_Initialize()
        SEL_Initialize()
        LAeqAndPercentile_Init()
        TC_Initialize()
    End Sub

    Private Sub ReinitAllArraysDay()
        ' ---------------------------------------------------------- initializations
        LAeqDayCounter = 0
        Lday = 0
        SumLAFday = 0
    End Sub

    Private Sub ReinitAllArraysEvening()
        ' ---------------------------------------------------------- initializations
        LAeqEveningCounter = 0
        Levening = 0
        SumLAFEvening = 0
    End Sub

    Private Sub ReinitAllArraysNight()
        ' ---------------------------------------------------------- initializations
        LAeqNightCounter = 0
        Lnight = 0
        SumLAFNight = 0
    End Sub

    Private Sub ReinitAllArraysDen()
        ' ---------------------------------------------------------- initializations
        LAeqDenCounter = 0
        LAeqDenTotal = 0
        'LAeqDen = 0
        SumLAFden = 0
        LAeqDenTotal_MinutesCounter = 0
    End Sub

    Private Sub ReadAllFileLines()
        ' 
        EnableReport = False
        '
        Dim flen As Int64 = m_FileStream.Length
        If flen > 1000000 Then Form1.ProgressBar1.Show() : Form1.ProgressBar1.BringToFront()
        Form1.Timer1.Stop()
        ReDim LoadedLines((MaxHours * 3600 * 1000) \ RowTimeMS)
        LoadedNumLines = 0
        While ScanEnabled And Not m_Streamreader.EndOfStream
            LoadedLines(LoadedNumLines) = m_Streamreader.ReadLine
            AnalyzeSingleLine(LoadedLines(LoadedNumLines))
            LoadedNumLines += 1
            If LoadedNumLines Mod 2000 = 0 Then
                Form1.ProgressBar1.Value = CInt(100 * m_FileStream.Position / m_FileStream.Length)
                If ScanEnabled Then
                    Form1.chk_ScanPeriod.Text = "SCANNING " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf + "( Click or ESC to stop )"
                End If
                Application.DoEvents()
            End If
        End While
        Form1.ProgressBar1.Hide()
        Form1.Timer1.Start()
        Form1.Refresh()
        LimitDeltaSamples()
    End Sub

    Friend ScanEnabled As Boolean

    Friend Sub ReadLastLine()
        If Not ScanEnabled Then Return
        If m_Streamreader Is Nothing Then Return
        If Not m_FileStream.CanRead Then Return
        Dim line As String = m_Streamreader.ReadLine()
        If line Is Nothing Then Return
        LoadedLines(LoadedNumLines) = line
        AnalyzeSingleLine(line)
        LoadedNumLines += 1
        GraphPaper1.UpdateTimeGraph()
        LimitDeltaSamples()
        Form1.pbox_TimeGraph.Refresh()
    End Sub


    ' ---------------------------------------------------------------------------------
    '   Create Middle Band Values
    ' ---------------------------------------------------------------------------------
    Friend MiddleBandsValues(NumBands) As Single
    Friend SumBandsValues(NumBands) As Single
    Private CounterValue As Int32

    'Friend Sub CreateMiddleBandValues()
    '    PrepareFileName()
    '    If Not ValidFileName() Then Return
    '    OpenInputFile()

    '    ReDim MiddleBandsValues(NumBands)
    '    CounterValue = 0

    '    m_FileStream.Position = 0
    '    While Not m_Streamreader.EndOfStream
    '        Dim s As String = m_Streamreader.ReadLine
    '        If s <> "" Then
    '            sa = Split(s, vbTab)
    '            For i As Int32 = 0 To NumBands - 1
    '                MiddleBandsValues(i) += CSng(10 ^ (0.1 * Val_Single(sa(i))))
    '            Next
    '            CounterValue += 1
    '        End If
    '    End While
    '    m_FileStream.Position = 0
    '    'TODO ---------------------------------------------------------------------------
    '    'CloseInputFile()
    '    For i As Int32 = 0 To NumBands - 1
    '        MiddleBandsValues(i) = CSng(10 * Math.Log10(MiddleBandsValues(i) / CounterValue))
    '    Next
    'End Sub


    Friend Sub CreateMiddleBandValues()
        'ReDim Preserve MiddleBandsValues(NumBands - 1)
        For i As Int32 = 0 To NumBands - 1
            SumBandsValues(i) += CSng(10 ^ (0.1 * CSng(Array_FastZ(i))))
        Next
        CounterValue += 1
        For j As Int32 = 0 To NumBands - 1
            'TODO -----------------------------------------------------------
            MiddleBandsValues(j) = CSng(10 * Math.Log10(SumBandsValues(j) / CounterValue))
        Next
    End Sub

    Friend Sub SetToZeroSumBandsValues()
        For i As Int32 = 0 To NumBands - 1
            SumBandsValues(i) = 0
        Next
    End Sub

    ' ---------------------------------------------------------------------------------
    '   ANALYZE SINGLE LINE
    ' ---------------------------------------------------------------------------------
    Private Sub AnalyzeSingleLine(ByVal line As String)
        ' -------------------------------------------------------
        If DataArray1 Is Nothing Then Return
        ' ------------------------------------------------------- split and test the element number
        sa = Split(line, vbTab)
        If sa.Length <> NumBands + 1 Then Return
        ' ------------------------------------------------------- read line elements
        For i As Int32 = 0 To NumBands - 1
            Array_Raw(i) = Val(sa(i + 1))
        Next
        ' ------------------------------------------------------- calc year day hour ... millisec from file
        RowDateTime += New TimeSpan(0, 0, 0, 0, RowTimeMS)

        ' ------------------------------------------------------- sync RowDateTime with Row HMS
        Sync_RowDateTime_WithRowHMS(sa(0))

        ' ------------------------------------------------------- test day night periods
        DayNight_Test()
        DayEveningNight_Test()
        ' ------------------------------------------------------- ponderate A
        Array_PondA = AddPondA(Array_Raw)
        ' ------------------------------------------------------- filters ImpulseA
        CalcFilters(Filters_ImpulseA, Array_PondA, Array_ImpulseA)
        ' ------------------------------------------------------- filters FastA
        CalcFilters(Filters_FastA, Array_PondA, Array_FastA)
        ' ------------------------------------------------------- filters SlowA
        CalcFilters(Filters_SlowA, Array_PondA, Array_SlowA)
        ' ------------------------------------------------------- ponderate C
        Array_PondC = AddPondC(Array_Raw)
        ' ------------------------------------------------------- filters PeakC
        CalcFilters(Filters_PeakC, Array_PondC, Array_PeakC)
        ' ------------------------------------------------------- filters FastZ cioè senza ponderazione 
        CalcFilters(Filters_FastZ, Array_Raw, Array_FastZ)
        'TODO ----------------------------------------------
        CreateMiddleBandValues()
        ' ------------------------------------------------------- calc the Sound Level for this row
        Row_LCP = Calc_RowSoundLevel(Array_PeakC)
        Row_LAI = Calc_RowSoundLevel(Array_ImpulseA)
        Row_LAF = Calc_RowSoundLevel(Array_FastA)
        Row_LAS = Calc_RowSoundLevel(Array_SlowA)

        ' ------------------------------------------------------- calc the LAeq progressive
        SumLAF += 10 ^ (0.1 * Row_LAF)
        Calc_LAeqProgressive(SumLAF)
        ' ------------------------------------------------------- calc Lday, Levening, Lnight, Lden ' 12/03/24
        If DayEveningNightString = "D" Then
            SumLAFday += 10 ^ (0.1 * Row_LAF)
            Calc_LAeqDay(SumLAFday) ' dalle 06:00 alle 20:00 Lday
        End If
        If DayEveningNightString = "E" Then
            SumLAFEvening += 10 ^ (0.1 * Row_LAF)
            Calc_LAeqEvening(SumLAFEvening) ' dalle 20:00 alle 22:00 Levening
        End If
        If DayEveningNightString = "N" Then
            SumLAFNight += 10 ^ (0.1 * Row_LAF)
            Calc_LAeqNight(SumLAFNight) ' dalle 22:00 alle 06:00 Lnignt
        End If
        'SumLAFden += 10 ^ (0.1 * Row_LAF)
        Calc_LAeqDen() ' Lden = Funzione di Lday, Levening, Lnight

        ' ------------------------------------------------------- add row for graphics data array
        DataArray1.AddElement(Row_LAI, _
                              Row_LAF, _
                              Row_LAS, _
                              LAeqProgressive, _
                              RowDateTime, _
                              line)
        ' ------------------------------------------------------- LCPeak max
        LMaxPeakC = Math.Max(LMaxPeakC, Row_LCP)
        Form1.Lbl_LCPeak.Text = "LPeakC = " + Row_LCP.ToString("0.0", GCI) '+ vbCrLf
        Form1.Lbl_LCPeakMax.Text = "LMaxPeakC = " + LMaxPeakC.ToString("0.0", GCI) '+ vbCrLf
        ' ------------------------------------------------------- impulsive components
        Find_ImpulsiveComponents()
        ' ------------------------------------------------------- tonal components
        'Find_Tonal_Components(Array_PondA)
        ' ------------------------------------------------------- LAeq and Percentile integration
        LAeqAndPercentile_Integration()
        ' ------------------------------------------------------- Update SEL (Single Event Level)
        SEL_Update()
        ' ------------------------------------------------------- test LAeq and percentile intervals
        TestIntervals()
        '
        ' ------------------------------------------------------- TEST - print array row
        'FilteredArrays_Print()
        '
        ' ------------------------------------------------------- test Tonal Components
        TC_CollectComponentsArray()
    End Sub



    ' ===================================================================================================
    '  READ and SYNC the ROW DATE TIME
    ' ===================================================================================================
    Private Sub ReadFirstRowDateTimeFromFile()
        m_FileStream.Position = 0
        While Not m_Streamreader.EndOfStream
            Dim s As String = m_Streamreader.ReadLine
            If s <> "" Then
                RowDateTime = FileDate
                sa = Split(s, vbTab)
                Sync_RowDateTime_WithRowHMS(sa(0))
                Exit While
            End If
        End While
        m_FileStream.Position = 0
    End Sub

    Private Sub Sync_RowDateTime_WithRowHMS(ByVal row As String)
        '
        'Dim sw1 As Diagnostics.Stopwatch = New Diagnostics.Stopwatch : sw1.Start()
        '
        ' ------------------------------------------------------------------- extract H:M:S fff from file
        If row.Length <> 12 Then Return
        Dim sa() As String = row.Split(":"c)
        If sa.Length < 3 Then Return
        Dim h As Int32 = CInt(Val(sa(0)))
        Dim m As Int32 = CInt(Val(sa(1)))
        sa = sa(2).Split(" "c)
        If sa.Length < 2 Then Return
        Dim s As Int32 = CInt(Val(sa(0)))
        Dim ms As Int32 = CInt(Val(sa(1)))
        ' -------------------------------------------------------------------- compose the DateTime
        Dim NewDateTime As DateTime = New DateTime(RowDateTime.Year, _
                                                   RowDateTime.Month, _
                                                   RowDateTime.Day, _
                                                   h, m, s, ms)
        ' -------------------------------------------------------------------- test if changed more than 1 sec
        ' TODO ------------------------------------------------- Pursuit 24
        If Math.Abs(NewDateTime.Subtract(RowDateTime).TotalMilliseconds) > 100 Then 'con valori superiori a 500 ms a volte non avanza al giorno successivo, metto 100 ms per sicurezza 
            'If Math.Abs(NewDateTime.Subtract(RowDateTime).TotalSeconds) > 1 Then 
            RowDateTime = NewDateTime 'senza questo non fa lo stacco fra giorni diversi ma accoda tutti i dati anche se di periodi differenti
            'Debug.Print("Scope time: " & (sw1.Elapsed.TotalMilliseconds * 1000).ToString("0.0", GCI) & " uS")
        End If
    End Sub


    ' ===================================================================================================
    '  FILTERS
    ' ===================================================================================================
    Private Sub CalcFilters(ByVal filterArray() As Filter, ByVal InArray() As Double, ByRef OutArray() As Double)
        For i As Int32 = 0 To NumBands - 1
            OutArray(i) = filterArray(i).Run(InArray(i))
        Next
    End Sub


    ' ===================================================================================================
    '  LEQ and PERCENTILE
    ' ===================================================================================================
    Private LAeqPartial As Double
    Private LAeqTotal As Double
    Private LAeqDenTotal As Double

    Private L1par As Double
    Private L5par As Double
    Private L10par As Double
    Private L25par As Double
    Private L50par As Double
    Private L75par As Double
    Private L90par As Double
    Private L95par As Double
    Private L99par As Double

    Private L1tot As Double
    Private L5tot As Double
    Private L10tot As Double
    Private L25tot As Double
    Private L50tot As Double
    Private L75tot As Double
    Private L90tot As Double
    Private L95tot As Double
    Private L99tot As Double

    Private Sub LAeqAndPercentile_Init()
        LAeqPartial = 0
        LAeqTotal = 0
        LAeqProgressive = 0
        SumLAF = 0

        L1par = 0
        L5par = 0
        L10par = 0
        L25par = 0
        L50par = 0
        L75par = 0
        L90par = 0
        L95par = 0
        L99par = 0

        L1tot = 0
        L5tot = 0
        L10tot = 0
        L25tot = 0
        L50tot = 0
        L75tot = 0
        L90tot = 0
        L95tot = 0
        L99tot = 0

        ' ----------------------------------------------------------------- dim arrays for 24 hours interval
        InitializePercentilePartialArrayFor24H()
        InitializePercentileTotalArrayFor24H()
    End Sub

    Private Sub InitializePercentilePartialArrayFor24H()
        ReDim PercentilePartialArray((MaxHours * 3600 * 1000) \ RowTimeMS)
    End Sub

    Private Sub InitializePercentileTotalArrayFor24H()
        ReDim PercentileTotalArray((MaxHours * 3600 * 1000) \ RowTimeMS)
    End Sub

    Private Sub LAeqAndPercentile_Integration()
        LAeqPartial += 10 ^ (0.1 * Row_LAF)
        ' -------------------------------------------------------
        LAeqTotal += 10 ^ (0.1 * Row_LAF)
        LAeqDenTotal += 10 ^ (0.1 * Row_LAF)
        ' ------------------------------------------------------- 
        If PercentilePartialRowCounter < PercentilePartialArray.Length Then
            PercentilePartialArray(PercentilePartialRowCounter) = Row_LAF
        End If
        ' ------------------------------------------------------- 
        If PercentilePartialRowCounter < PercentilePartialArray.Length Then
            PercentileTotalArray(PercentileTotalRowCounter) = Row_LAF
        End If
    End Sub

    Private Sub Calc_LAeqProgressive(ByVal L As Double)
        LAeqProgressive = 10 * Math.Log10(L / (LAeqProgressiveCounter + 1))
    End Sub

    Private Sub LAeqPartial_EndPeriod()
        LAeqPartial = 10 * Math.Log10(LAeqPartial / (LAeqPartial_MinutesCounter * 60000 / RowTimeMS))
    End Sub

    Private Sub LAeqTotal_EndPeriod()
        LAeqTotal = 10 * Math.Log10(LAeqTotal / (LAeqTotal_MinutesCounter * 60000 / RowTimeMS))
    End Sub



    'Private Sub PercentilePartial_EndPeriod()
    '    If PercentilePartialRowCounter < 100 Then Return
    '    ReDim Preserve PercentilePartialArray(PercentilePartialRowCounter - 1)
    '    Array.Sort(PercentilePartialArray)
    '    L1par = Lpercentile(1, PercentilePartialArray)
    '    L5par = Lpercentile(5, PercentilePartialArray)
    '    L10par = Lpercentile(10, PercentilePartialArray)
    '    L25par = Lpercentile(25, PercentilePartialArray)
    '    L50par = Lpercentile(50, PercentilePartialArray)
    '    L75par = Lpercentile(75, PercentilePartialArray)
    '    L90par = Lpercentile(90, PercentilePartialArray)
    '    L95par = Lpercentile(95, PercentilePartialArray)
    '    L99par = Lpercentile(99, PercentilePartialArray)
    '    InitializePercentilePartialArrayFor24H()
    '    PercentilePartialRowCounter = 0
    'End Sub

    'Private Sub PercentileTotal_EndPeriod()
    '    If PercentileTotalRowCounter < 100 Then Return
    '    ReDim Preserve PercentileTotalArray(PercentileTotalRowCounter - 1)
    '    Array.Sort(PercentileTotalArray)
    '    L1tot = Lpercentile(1, PercentileTotalArray)
    '    L5tot = Lpercentile(5, PercentileTotalArray)
    '    L10tot = Lpercentile(10, PercentileTotalArray)
    '    L25tot = Lpercentile(25, PercentileTotalArray)
    '    L50tot = Lpercentile(50, PercentileTotalArray)
    '    L75tot = Lpercentile(75, PercentileTotalArray)
    '    L90tot = Lpercentile(90, PercentileTotalArray)
    '    L95tot = Lpercentile(95, PercentileTotalArray)
    '    L99tot = Lpercentile(99, PercentileTotalArray)
    '    InitializePercentileTotalArrayFor24H()
    '    PercentileTotalRowCounter = 0
    'End Sub

    Friend Sub ReadPercentilesSet()
        Dim n1() As Int32 = {1, 5, 10, 50, 90, 95, 99}
        Dim n2(6) As Int32
        '
        Dim s As String = ReplaceMultipleSpacesAndTabAndTrim(Form1.Txt_Percentiles_levels.Text)
        Dim sa() As String = s.Split(" "c)
        '
        If sa.Length = 7 Then
            For i As Int32 = 0 To 6
                n2(i) = Val_Int(sa(i))
            Next
        Else
            n2 = n1
        End If
        '
        Array.Sort(n2)
        '
        PercentilesValueSet(0) = n2(0)
        PercentilesValueSet(1) = n2(1)
        PercentilesValueSet(2) = n2(2)
        PercentilesValueSet(3) = 25
        PercentilesValueSet(4) = n2(3)
        PercentilesValueSet(5) = 75
        PercentilesValueSet(6) = n2(4)
        PercentilesValueSet(7) = n2(5)
        PercentilesValueSet(8) = n2(6)
    End Sub


    Friend PercentilesValueSet() As Int32 = {1, 5, 10, 25, 50, 75, 90, 95, 99}

    Private Sub PercentilePartial_EndPeriod()
        If PercentilePartialRowCounter < 100 Then Return
        ReDim Preserve PercentilePartialArray(PercentilePartialRowCounter - 1)
        Array.Sort(PercentilePartialArray)
        L1par = Lpercentile(PercentilesValueSet(0), PercentilePartialArray)
        L5par = Lpercentile(PercentilesValueSet(1), PercentilePartialArray)
        L10par = Lpercentile(PercentilesValueSet(2), PercentilePartialArray)
        L25par = Lpercentile(PercentilesValueSet(3), PercentilePartialArray)
        L50par = Lpercentile(PercentilesValueSet(4), PercentilePartialArray)
        L75par = Lpercentile(PercentilesValueSet(5), PercentilePartialArray)
        L90par = Lpercentile(PercentilesValueSet(6), PercentilePartialArray)
        L95par = Lpercentile(PercentilesValueSet(7), PercentilePartialArray)
        L99par = Lpercentile(PercentilesValueSet(8), PercentilePartialArray)
        InitializePercentilePartialArrayFor24H()
        PercentilePartialRowCounter = 0
    End Sub

    Private Sub PercentileTotal_EndPeriod()
        If PercentileTotalRowCounter < 100 Then Return
        ReDim Preserve PercentileTotalArray(PercentileTotalRowCounter - 1)
        Array.Sort(PercentileTotalArray)
        L1tot = Lpercentile(PercentilesValueSet(0), PercentileTotalArray)
        L5tot = Lpercentile(PercentilesValueSet(1), PercentileTotalArray)
        L10tot = Lpercentile(PercentilesValueSet(2), PercentileTotalArray)
        L25tot = Lpercentile(PercentilesValueSet(3), PercentileTotalArray)
        L50tot = Lpercentile(PercentilesValueSet(4), PercentileTotalArray)
        L75tot = Lpercentile(PercentilesValueSet(5), PercentileTotalArray)
        L90tot = Lpercentile(PercentilesValueSet(6), PercentileTotalArray)
        L95tot = Lpercentile(PercentilesValueSet(7), PercentileTotalArray)
        L99tot = Lpercentile(PercentilesValueSet(8), PercentileTotalArray)

        DistributionEachdB()

        InitializePercentileTotalArrayFor24H()
        PercentileTotalRowCounter = 0
    End Sub

    Friend Function Lpercentile(ByVal n As Int32, ByVal vec() As Double) As Double
        If n > 100 Then n = 100
        n = 100 - n
        Return vec(CInt(n * vec.Length / 100))
    End Function

    Friend DistributionArray() As Int32
    Friend Sub DistributionEachdB()
        ReDim DistributionArray(199)
        For i As Int32 = 0 To PercentileTotalArray.Length - 1
            DistributionArray(CInt(PercentileTotalArray(i))) += 1
        Next
        DistributionArray(0) = 0
    End Sub


    ' ===================================================================================================
    '  INDICATORI ACUSTICI Lden, Lday, Levening, Lnight
    ' ===================================================================================================
    Private Sub Calc_LAeqDay(ByVal L As Double)
        Lday = 10 * Math.Log10(L / (LAeqDayCounter + 1))
    End Sub
    Private Sub Calc_LAeqEvening(ByVal L As Double)
        Levening = 10 * Math.Log10(L / (LAeqEveningCounter + 1))
    End Sub
    Private Sub Calc_LAeqNight(ByVal L As Double)
        Lnight = 10 * Math.Log10(L / (LAeqNightCounter + 1))
    End Sub
    Private Sub Calc_LAeqDen()
        If Lday > 0 And Levening > 0 And Lnight > 0 Then
            Lden = 10 * Math.Log10((1 / 24) * (14 * 10 ^ (0.1 * Lday) + 2 * 10 ^ (0.1 * (Levening + 5)) + 8 * 10 ^ (0.1 * (Lnight + 10))))
        Else
            Return
        End If
    End Sub
    Private Sub LAeqDenTotal_EndPeriod()
        LAeqDenTotal = 10 * Math.Log10(LAeqDenTotal / (LAeqDenTotal_MinutesCounter * 60000 / RowTimeMS))
    End Sub
    ' 
    Private Sub LAeqPartial_Update()
        LAeqPartialString += RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + _
                               " LAeq = " & LAeqPartial.ToString("0.0", GCI) + vbCrLf
    End Sub

    Private Sub LAeqTotal_Update()
        LAeqTotalString += " Total" + vbCrLf
        LAeqTotalString += RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + _
                               " LAeq = " & LAeqTotal.ToString("0.0", GCI) + vbCrLf
    End Sub

    Private Sub LAeqDenTotal_Update()
        LAeqDenTotalString += " Total" + vbCrLf
        LAeqDenTotalString += RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + _
                               " Lden = " & LAeqDenTotal.ToString("0.0", GCI) + vbCrLf
    End Sub

    Private Sub PercentilePartial_Update()
        PercentilePartialString += RowDateTime.ToString("yyyy/MM/dd HH:mm:ss  ") + _
                                   PercToStr(L1par) + _
                                   PercToStr(L5par) + _
                                   PercToStr(L10par) + _
                                   PercToStr(L50par) + _
                                   PercToStr(L90par) + _
                                   PercToStr(L95par) + _
                                   PercToStr(L99par) + vbCrLf
    End Sub

    Private Sub PercentileTotal_Update()
        PercentileTotalString += " Total" + vbCrLf
        PercentileTotalString += RowDateTime.ToString("yyyy/MM/dd HH:mm:ss  ") + _
                               PercToStr(L1tot) + _
                               PercToStr(L5tot) + _
                               PercToStr(L10tot) + _
                               PercToStr(L50tot) + _
                               PercToStr(L90tot) + _
                               PercToStr(L95tot) + _
                               PercToStr(L99tot) + vbCrLf
    End Sub

    Private Function PercToStr(ByVal perc As Double) As String
        If perc >= 99.5 Then
            Return perc.ToString("0  ")
        ElseIf perc >= 9.5 Then
            Return perc.ToString("0.0 ", GCI)
        Else
            Return perc.ToString(" 0.0 ", GCI)
        End If
    End Function


    Private OldDay As Int32
    Private OldMinute As Int32

    Private Sub ResetAllCounters()
        OldDay = RowDateTime.Day
        OldMinute = RowDateTime.Minute
        LAeqPartial_MinutesCounter = 0
        PercentilePartial_MinutesCounter = 0
        LAeqTotal_MinutesCounter = 0
        PercentileTotal_MinutesCounter = 0
        PercentilePartialRowCounter = 0
        PercentileTotalRowCounter = 0
        LAeqProgressiveCounter = 0
        Row_LAI = 0
        Row_LAF = 0
        Row_LAS = 0
        LAeqPartialString = ""
        LAeqTotalString = ""
        PercentilePartialString = ""
        PercentileTotalString = ""
    End Sub

    Private Sub IncrementAllCounters()
        ' -------------------------------------------------- each row
        PercentilePartialRowCounter += 1
        PercentileTotalRowCounter += 1
        LAeqProgressiveCounter += 1
        LAeqDayCounter += 1
        LAeqEveningCounter += 1
        LAeqNightCounter += 1
        LAeqDenCounter += 1
        ' -------------------------------------------------- each minute
        If RowDateTime.Minute = OldMinute Then Return
        OldMinute = RowDateTime.Minute
        LAeqPartial_MinutesCounter += 1
        PercentilePartial_MinutesCounter += 1
        LAeqTotal_MinutesCounter += 1
        LAeqDenTotal_MinutesCounter += 1
        PercentileTotal_MinutesCounter += 1
    End Sub

    Private Sub TestIntervals()
        IncrementAllCounters()
        If LAeqPartial_MinutesCounter >= LAeqInterval Then
            LAeqPartial_EndPeriod()
            ' ----------------------------------------------- test if LAeg is enough ti send a mail
            Form1.TestSendMail(LAeqPartial, TestSite)
            ' -------------------------------------------------------------------------------------
            LAeqPartial_MinutesCounter = 0
            LAeqPartial_Update()
            PrintPeriodicReport(ReportTypes.LAeqInterval)
        End If
        If PercentilePartial_MinutesCounter >= PercentileInterval Then
            PercentilePartial_EndPeriod()
            PercentilePartial_MinutesCounter = 0
            PercentilePartial_Update()
            PrintPeriodicReport(ReportTypes.PercentileInterval)
        End If
    End Sub


    ' ===================================================================================================
    '  DAY and NIGHT functions
    ' ===================================================================================================
    Private Sub DayNight_Init()
        InitDayNightString()
        'TODO -------------------------------------------------------------------------------------------
        'InitDayEveningNightString()
        If IsTimeMoreOrEqualThen(RowDateTime, StartNightPeriod) Then
            WaitMidnight = True
        Else
            WaitMidnight = False
        End If
    End Sub
    'TODO ------------------------------

    'Private Sub DayEveningNight_Init()
    '    InitDayEveningNightString()
    '    If IsTimeMoreOrEqualThen(RowDateTime, StartNightPeriod) Then
    '        WaitMidnight = True
    '    Else
    '        WaitMidnight = False
    '    End If
    'End Sub

    Private WaitMidnight As Boolean
    Private Sub DayNight_Test()
        '
        If PeriodsCount > 0 Then
            If DayNightString = "D" And IsTimeMoreOrEqualThen(RowDateTime, StartNightPeriod) Then
                DayNightString = "N"
                WaitMidnight = True
                PercentileTotal_EndPeriod()
                PercentileTotal_Update()
                LAeqTotal_EndPeriod()
                LAeqTotal_Update()
                PrintPeriodicReport(ReportTypes.EndOfDay_H22)
                ReinitAllArrays()
                PeriodsCounter += 1
            End If
            '
            If DayNightString = "N" And IsTimeMoreOrEqualThen(RowDateTime, StartDayPeriod) And Not WaitMidnight Then
                DayNightString = "D"
                PercentileTotal_EndPeriod()
                PercentileTotal_Update()
                LAeqTotal_EndPeriod()
                LAeqTotal_Update()
                PrintPeriodicReport(ReportTypes.EndOfNight_H06)
                ReinitAllArrays()
                PeriodsCounter += 1
            End If
        End If
        '
        If RowDateTime.Day <> OldDay Then
            OldDay = RowDateTime.Day
            WaitMidnight = False
        End If
    End Sub

    Private Sub InitDayNightString()
        If IsTimeMoreOrEqualThen(RowDateTime, StartDayPeriod) And IsTimeLessThen(RowDateTime, StartNightPeriod) Then
            DayNightString = "D"
        Else
            DayNightString = "N"
        End If
    End Sub


    Private Sub DayEveningNight_Test()
        If DayEveningNightString = "D" And IsTimeMoreOrEqualThen(RowDateTime, StartOfEveningPeriod_H20) Then
            DayEveningNightString = "E"
            ReinitAllArraysEvening()
            PrintPeriodicReport(ReportTypes.StartOfEvening_H20)
        End If
        '
        If DayEveningNightString = "E" And IsTimeMoreOrEqualThen(RowDateTime, StartOfNightPeriod_H22) Then
            DayEveningNightString = "N"
            'If Not WaitMidnight Then ReinitAllArraysNight() 'reinizializza il night non dopo le 22 ma solo se è appena trascorsa la mezzanotte
            PrintPeriodicReport(ReportTypes.StartOfNight_H22)
            ReinitAllArraysNight()
        End If
        '
        If DayEveningNightString = "N" And IsTimeMoreOrEqualThen(RowDateTime, StartOfDayPeriod_H06) And Not WaitMidnight Then
            DayEveningNightString = "D"
            ReinitAllArraysDay()
            PrintPeriodicReport(ReportTypes.StartOfDay_H06)
        End If
    End Sub


    Friend Sub InitDayEveningNightString()
        If IsTimeMoreOrEqualThen(RowDateTime, StartOfDayPeriod_H06) And IsTimeLessThen(RowDateTime, StartOfEveningPeriod_H20) Then
            If Not DayEveningNightString = "D" Then
                ReinitAllArraysDay()
            End If
            DayEveningNightString = "D"
        End If
        If IsTimeMoreOrEqualThen(RowDateTime, StartOfEveningPeriod_H20) And IsTimeLessThen(RowDateTime, StartOfNightPeriod_H22) Then
            If Not DayEveningNightString = "E" Then
                ReinitAllArraysEvening()
            End If
            DayEveningNightString = "E"
        End If
        If IsTimeMoreOrEqualThen(RowDateTime, StartOfNightPeriod_H22) Or IsTimeLessThen(RowDateTime, StartOfDayPeriod_H06) Then
            If Not DayEveningNightString = "N" Then
                ReinitAllArraysNight()
            End If
            DayEveningNightString = "N"
        End If
    End Sub

    Private Function IsTimeMoreOrEqualThen(ByVal dt As DateTime, ByVal HourAndFraction As Single) As Boolean
        Dim t As Single = dt.Hour + dt.Minute / 60.0F
        Return t >= HourAndFraction
    End Function

    Private Function IsTimeLessThen(ByVal dt As DateTime, ByVal HourAndFraction As Single) As Boolean
        Dim t As Single = dt.Hour + dt.Minute / 60.0F
        Return t < HourAndFraction
    End Function

    Private Function DayPeriodString() As String
        Return HourAndFraction_To_HoursAndMinutes(StartDayPeriod) + " to " + HourAndFraction_To_HoursAndMinutes(StartNightPeriod)
    End Function
    Private Function NightPeriodString() As String
        Return HourAndFraction_To_HoursAndMinutes(StartNightPeriod) + " to " + HourAndFraction_To_HoursAndMinutes(StartDayPeriod)
    End Function

    Private Function DenDayPeriodString() As String
        Return HourAndFraction_To_HoursAndMinutes(StartOfDayPeriod_H06) + " to " + HourAndFraction_To_HoursAndMinutes(StartOfEveningPeriod_H20)
    End Function
    Private Function DenEveningPeriodString() As String
        Return HourAndFraction_To_HoursAndMinutes(StartOfEveningPeriod_H20) + " to " + HourAndFraction_To_HoursAndMinutes(StartOfNightPeriod_H22)
    End Function
    Private Function DenNightPeriodString() As String
        Return HourAndFraction_To_HoursAndMinutes(StartOfNightPeriod_H22) + " to " + HourAndFraction_To_HoursAndMinutes(StartOfDayPeriod_H06)
    End Function

    Private Function HourAndFraction_To_HoursAndMinutes(ByVal hf As Single) As String
        Dim h As Int32 = CInt(hf)
        Dim f As Single = hf - h
        If f = 0 Then Return h.ToString
        Return h.ToString + ":" + CInt(60 * f).ToString
    End Function


    ' ===================================================================================================
    '  Search impulsive components
    ' ===================================================================================================
    Private CInight As String
    Private CIday As String
    Private Start_time As DateTime
    Private Count_impulse As Int32

    Private Sub Find_ImpulsiveComponents_Initialize()
        CInight = ""
        CIday = ""
        Start_time = RowDateTime
        Count_impulse = 0
        ImpulseStatus = ImpulseStates.WaitingMax
    End Sub

    Private Enum ImpulseStates
        WaitingMax
        WaitingEndOfPulse
    End Enum
    Private ImpulseStatus As ImpulseStates = ImpulseStates.WaitingMax
    Private FastMax_Time As DateTime
    Private FastMax_DB As Double

    Private Sub Find_ImpulsiveComponents()
        Select Case ImpulseStatus

            Case ImpulseStates.WaitingMax
                If Row_LAI - Row_LAS > 6 Then
                    ImpulseStatus = ImpulseStates.WaitingEndOfPulse
                    FastMax_DB = Row_LAF
                    FastMax_Time = RowDateTime
                End If

            Case ImpulseStates.WaitingEndOfPulse
                If FastMax_DB - Row_LAF > 10 Then
                    Dim s As String = FastMax_Time.ToString("yyyy/MM/dd HH:mm:ss +fff") + " mS  " + _
                                      FastMax_DB.ToString("0.0", GCI) + " dB" + vbCrLf
                    If DayNightString = "N" Then
                        CInight += s
                    Else
                        CIday += s
                    End If
                    ImpulseStatus = ImpulseStates.WaitingMax
                    FastMax_Time = RowDateTime
                End If
                If RowDateTime.Subtract(FastMax_Time).TotalMilliseconds > 1000 Then
                    ImpulseStatus = ImpulseStates.WaitingMax
                End If

        End Select
    End Sub

    Private Function SelectValidImpulsiveComponents(ByRef StringCI As String, ByVal NumImpulses As Int32) As String
        If StringCI = Nothing Then Return ""
        Dim sa() As String = StringCI.Split(New String() {vbCrLf}, _
                                            StringSplitOptions.RemoveEmptyEntries)
        Dim SelectedCI As String = ""
        For i As Int32 = 0 To sa.Length - 1
            Dim t1 As DateTime = ParseDateFromString(sa(i))
            ' -----------------------------------------------------------
            Dim lastImpulseIndex As Int32 = i + NumImpulses - 1
            If lastImpulseIndex >= sa.Length Then Exit For
            ' -----------------------------------------------------------
            Dim t2 As DateTime = ParseDateFromString(sa(lastImpulseIndex))
            If t2.Subtract(t1).TotalMinutes < 60 Then
                For j As Int32 = i To lastImpulseIndex
                    SelectedCI += sa(j) + vbCrLf
                Next
                SelectedCI += vbCrLf
                i = lastImpulseIndex
                If i >= sa.Length Then Exit For
            End If
        Next
        Return SelectedCI
    End Function

    Friend Sub DecodeDateAndMoveGraphPaper(ByVal nline As Int32)
        Dim d As DateTime
        If nline >= Form1.TextBox_Reports.Lines.Length Then Return
        d = ParseDateFromString(Form1.TextBox_Reports.Lines(nline))
        'Form1.Text = d.ToString
        If d <> Date.MinValue Then
            GraphPaper1.ShowTimePoint(d)
        End If
    End Sub

    Private Function ParseDateFromString(ByVal s As String) As DateTime
        Dim d As DateTime
        Dim res As Boolean
        s = s.Replace("-", "")
        s = s.Trim
        s = Strings.Left(s, 24)
        res = DateTime.TryParseExact(s, "yyyy/MM/dd HH:mm:ss +fff", Nothing, Nothing, d)
        If Not res Then
            s = Strings.Left(s, 23)
            res = DateTime.TryParseExact(s, "yyyy/MM/dd HH:mm:ss fff", Nothing, Nothing, d)
        End If
        If Not res Then
            s = Strings.Left(s, 19)
            res = DateTime.TryParseExact(s, "yyyy/MM/dd HH:mm:ss", Nothing, Nothing, d)
        End If
        If Not res Then
            s = Strings.Left(s, 10)
            res = DateTime.TryParseExact(s, "yyyy/MM/dd", Nothing, Nothing, d)
        End If
        Return d
    End Function

    Private Function ParseFileDateFromString(ByVal s As String) As DateTime
        Dim d As DateTime
        DateTime.TryParseExact(s, "yyyy-MM-dd", Nothing, Nothing, d)
        Return d
    End Function


    ' ===================================================================================================
    '  SEL
    ' ===================================================================================================
    Friend SEL_MaxSeconds As Int32
    Private SEL_Status As SEL_States = SEL_States.WaitingMax
    Private SEL_MaxEvent_Time As DateTime
    Private SEL_MaxDB As Double
    '
    Private SEL_StartIndex As Int32
    Private SEL_MaxIndex As Int32
    Private SEL_EndIndex As Int32
    Private SEL_AllEvents As String
    '
    Private SEL As Double
    '
    Private Enum SEL_States
        WaitingMax
        WaitingEndOfEvent
    End Enum

    Private Sub SEL_Initialize()
        SEL_Status = SEL_States.WaitingMax
        SEL_MaxDB = 0
        SEL_StartIndex = DataArray1.GetWriteIndex - 1
        SEL_AllEvents = ""
    End Sub

    Private Sub SEL_Reinitialize()
        SEL_MaxDB = Row_LAF
        SEL_MaxEvent_Time = RowDateTime
        SEL_MaxIndex = DataArray1.GetWriteIndex - 1
    End Sub

    Private Sub SEL_Update()
        If SEL_MaxSeconds = 0 Then Return
        Select Case SEL_Status
            Case SEL_States.WaitingMax
                If Row_LAF > SEL_MaxDB Then
                    SEL_Status = SEL_States.WaitingEndOfEvent
                    SEL_Reinitialize()
                End If
            Case SEL_States.WaitingEndOfEvent
                If SEL_MaxDB - Row_LAF > 10 Then
                    ' -------------------------------------------- find start index
                    For i As Int32 = SEL_MaxIndex To 0 Step -1
                        ' -------------------------------------------- if too much time then exit from WaitEvent
                        If SEL_MaxEvent_Time.Subtract(DataArray1.GetElement(i).Time).TotalMilliseconds > SEL_MaxSeconds * 1000 Then
                            SEL_Status = SEL_States.WaitingMax
                            SEL_Reinitialize()
                            Exit Select
                        End If

                        ' -------------------------------------------- if this sample is more than max then exit from WaitEvent
                        'If DataArray1.GetElement(i).LAF > SEL_MaxDB Then
                        '    SEL_Status = SEL_States.WaitingMax
                        '    SEL_Reinitialize()
                        '    Exit Select
                        'End If


                        ' -------------------------------------------- test if reached the -10 dB point
                        If SEL_MaxDB - DataArray1.GetElement(i).LAF > 10 Then
                            SEL_StartIndex = i '- 1
                            Exit For
                        End If
                        ' -------------------------------------------- Because the array is not circular 
                        ' -------------------------------------------- and does not accept negative values
                        ' -------------------------------------------- we terminate with zero
                        If i = 0 Then
                            SEL_Status = SEL_States.WaitingMax
                            SEL_MaxDB = 0
                            Exit Select
                        End If
                        ' ---------------------------------------------------------------------------------
                        '
                    Next
                    ' -------------------------------------------- start to end integration
                    SEL_EndIndex = DataArray1.GetWriteIndex - 1
                    SEL = 0
                    For i As Int32 = SEL_StartIndex To SEL_EndIndex
                        SEL += 0.1 * 10 ^ (0.1 * DataArray1.GetElement(i).LAF)
                    Next
                    SEL = 10 * Math.Log10(SEL)

                    ' -------------------------------------------- 
                    DataArray1.SetFlags(SEL_StartIndex, DataArray.SEL_Flags.FirstSample)
                    DataArray1.SetFlags(SEL_MaxIndex, DataArray.SEL_Flags.MaxSample)
                    DataArray1.SetFlags(SEL_EndIndex, DataArray.SEL_Flags.LastSample)
                    ' -------------------------------------------- 
                    Dim StartTime As Date = DataArray1.GetElement(SEL_StartIndex).Time
                    Dim EndTime As Date = DataArray1.GetElement(SEL_EndIndex).Time
                    SEL_AllEvents += SEL_MaxEvent_Time.ToString("yyyy/MM/dd HH:mm:ss +fff") + _
                                     SEL.ToString("0.0").PadLeft(10) + _
                                     SEL_MaxDB.ToString("0.0").PadLeft(10) + _
                                     EndTime.Subtract(StartTime).TotalSeconds.ToString("0.0").PadLeft(9) + vbCrLf


                    ' -------------------------------------------- 
                    SEL_Status = SEL_States.WaitingMax
                    SEL_Reinitialize()
                End If
                ' ------------------------------------------------ if new max then exit from WaitEvent
                If Row_LAF > SEL_MaxDB Then
                    SEL_Status = SEL_States.WaitingMax
                    SEL_Reinitialize()
                    SEL_MaxDB = 0
                End If
                ' ------------------------------------------------ if too much time then exit from WaitEvent
                If RowDateTime.Subtract(SEL_MaxEvent_Time).TotalMilliseconds > SEL_MaxSeconds * 1000 Then
                    SEL_Status = SEL_States.WaitingMax
                    SEL_Reinitialize()
                End If
        End Select
    End Sub

    Private Sub SEL_PrintAllData()
        If SEL_MaxSeconds = 0 Then Return
        Form1.TextBox_Reports.Text += vbCrLf + _
                                      "========================================================" + vbCrLf + _
                                      " SEL (single event level) " + vbCrLf + _
                                      "------------------------------------------------------- " + vbCrLf + _
                                      "    DATE     TIME    mS    SEL LEVEL   MAX DB   SECONDS " + vbCrLf + _
                                      "========================================================" + vbCrLf
        Form1.TextBox_Reports.Text += SEL_AllEvents
    End Sub



    ' ===================================================================================================
    '  REPORT BLOCKS
    ' ===================================================================================================
    Friend Enum ReportTypes
        ShortReport
        EndOfFastLoad
        LAeqInterval
        PercentileInterval
        EndOfDay_H20
        StartOfDay_H06 ' valori costanti, non modificabili dal programma
        StartOfEvening_H20  ' valori costanti, non modificabili dal programma
        StartOfNight_H22  ' valori costanti, non modificabili dal programma
        EndOfDay_H22
        EndOfNight_H06
        Immediate
    End Enum

    Friend Sub PrintPeriodicReport(ByVal ReportType As ReportTypes)

        Dim WriteFile As Boolean = False
        'If ReportType = ReportTypes.EndOfDay_H22 Or ReportType = ReportTypes.EndOfNight_H06 Then '18/02/2024
        If ReportType = ReportTypes.EndOfDay_H22 Or ReportType = ReportTypes.EndOfNight_H06 Or ReportType = ReportTypes.Immediate Then
            WriteFile = True
        End If
        If Not EnableReport And Not WriteFile Then Return

        Form1.TextBox_Reports.Clear()
        Select Case ReportType
            Case ReportTypes.EndOfDay_H22
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of day period (" + DayPeriodString() + ") - " + RowDateTime.ToString("yyyy/MM/dd") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                'Webhook()
            Case ReportTypes.EndOfNight_H06
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of night period (" + NightPeriodString() + ") - " + RowDateTime.ToString("yyyy/MM/dd") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                'Webhook()

            Case ReportTypes.StartOfEvening_H20
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " Lday(" + DenDayPeriodString() + ") - " + RowDateTime.ToString("yyyy/MM/dd") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                'Webhook()
            Case ReportTypes.StartOfNight_H22
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " Levening (" + DenNightPeriodString() + ") - " + RowDateTime.ToString("yyyy/MM/dd") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                'Webhook()
            Case ReportTypes.StartOfDay_H06
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " Lnight (" + DenNightPeriodString() + ") - " + RowDateTime.ToString("yyyy/MM/dd") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                'Webhook()




            Case ReportTypes.ShortReport
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " SHORT REPORT - LAST DATA LISTED EVERY " + ReportsInterval.ToString + " MINUTES" + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
            Case ReportTypes.EndOfFastLoad
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of FastLoad - " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
            Case ReportTypes.LAeqInterval
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of LAeq interval - " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
            Case ReportTypes.PercentileInterval
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of Percentile interval - " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
            Case ReportTypes.Immediate
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
                Form1.TextBox_Reports.Text += " End of Immediate interval - " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf
                Form1.TextBox_Reports.Text += "########################################################" + vbCrLf
        End Select
        ' ---------------------------------------------------------------------
        '  LAeq and PERCENTILES
        ' ---------------------------------------------------------------------
        If LAeqPartialString <> "" Or LAeqTotalString <> "" Or _
           PercentilePartialString <> "" Or PercentileTotalString <> "" Then
            If ReportType = ReportTypes.ShortReport Then
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " LAeq and Percentiles" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += GetLastRowFromString(LAeqPartialString)
                If PercentilePartialString <> "" Then
                    Form1.TextBox_Reports.Text += vbCrLf
                    Form1.TextBox_Reports.Text += " Percentiles          L" + CStr(PercentilesValueSet(0)) + " L" + CStr(PercentilesValueSet(1)) + " L" + CStr(PercentilesValueSet(2)) + " L" + CStr(PercentilesValueSet(4)) + " L" + CStr(PercentilesValueSet(6)) + " L" + CStr(PercentilesValueSet(7)) + " L" + CStr(PercentilesValueSet(8)) + vbCrLf
                    Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                    Form1.TextBox_Reports.Text += GetLastRowFromString(PercentilePartialString)
                End If
            Else
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " LAeq and Percentiles" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += LAeqPartialString
                Form1.TextBox_Reports.Text += LAeqTotalString

                ' ---------------------------------------------------------------------
                '  Indicatori
                ' ---------------------------------------------------------------------
                Form1.TextBox_Reports.Text += vbCrLf + " Indicators" + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += vbCrLf + "Lday = " + Lday.ToString("0.0", GCI) + " period from " + StringStartOfDayPeriod_H06 + " to " + StringStartOfEveningPeriod_H20 + vbCrLf
                Form1.TextBox_Reports.Text += "Levening = " + Levening.ToString("0.0", GCI) + " period from " + StringStartOfEveningPeriod_H20 + " to " + StringStartOfNightPeriod_H22 + vbCrLf
                Form1.TextBox_Reports.Text += "Lnight = " + Lnight.ToString("0.0", GCI) + " period from " + StringStartOfNightPeriod_H22 + " to " + StringStartOfDayPeriod_H06 + vbCrLf

                Form1.TextBox_Reports.Text += "Lden = " + Lden.ToString("0.0", GCI) + " period from " + StringStartOfDayPeriod_H06 + " to " + StringStartOfDayPeriod_H06 + vbCrLf
                'TODO -------------------------------------------------------------- Lden
                'Form1.TextBox_Reports.Text += LAeqDenTotalString


                If PercentilePartialString <> "" Or PercentileTotalString <> "" Then
                    Form1.TextBox_Reports.Text += vbCrLf
                    Form1.TextBox_Reports.Text += " Percentiles          L" + CStr(PercentilesValueSet(0)) + " L" + CStr(PercentilesValueSet(1)) + " L" + CStr(PercentilesValueSet(2)) + " L" + CStr(PercentilesValueSet(4)) + " L" + CStr(PercentilesValueSet(6)) + " L" + CStr(PercentilesValueSet(7)) + " L" + CStr(PercentilesValueSet(8)) + vbCrLf
                    Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                    Form1.TextBox_Reports.Text += PercentilePartialString
                    Form1.TextBox_Reports.Text += PercentileTotalString
                End If
            End If

            ' ---------------------------------------------------------------- SEL
            SEL_PrintAllData()
        End If

        ' ---------------------------------------------------------------------
        '  IMPULSIVE COMPONENTS
        ' ---------------------------------------------------------------------
        Dim SelectedCI As String

        If CIday <> "" Or CInight <> "" Then
            If ReportType = ReportTypes.ShortReport Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " Impulsive components" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
            Else
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " Impulsive components" + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += " Impulse - Slow    > 6dB                                " + vbCrLf
                Form1.TextBox_Reports.Text += " Decay to FastMax - 10dB in less than 1 seconds         " + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
            End If
        End If

        If ReportType = ReportTypes.ShortReport Then
            ' ------------------------------------------------------- day
            If CIday <> "" Then
                Form1.TextBox_Reports.Text += " Day period (from " + DayPeriodString() + ") " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += GetLastRowFromString(CIday)
            End If
            ' ------------------------------------------------------- night
            If CInight <> "" Then
                If CIday <> "" Then Form1.TextBox_Reports.Text += vbCrLf + vbCrLf
                Form1.TextBox_Reports.Text += " Night period (from " + NightPeriodString() + ") " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += GetLastRowFromString(CInight)
            End If
        Else
            ' ------------------------------------------------------- day
            If CIday <> "" Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += " Day period (from " + DayPeriodString() + ") " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += CIday
            End If
            SelectedCI = SelectValidImpulsiveComponents(CIday, Day_hourly_impulses_for_impulsivity)
            If SelectedCI <> "" Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += " Day period - Selected (at least 10 for each hour)      " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += SelectedCI
            End If
            ' ------------------------------------------------------- night
            If CInight <> "" Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += " Night period (from " + NightPeriodString() + ") " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += CInight
            End If
            SelectedCI = SelectValidImpulsiveComponents(CInight, Night_hourly_impulses_for_impulsivity)
            If SelectedCI <> "" Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += " Night period - Selected (at least 2 for each hour)     " + vbCrLf
                Form1.TextBox_Reports.Text += "--------------------------------------------------------" + vbCrLf
                Form1.TextBox_Reports.Text += SelectedCI
            End If
        End If

        ' ---------------------------------------------------------------------
        '  TONAL COMPONENTS
        ' ---------------------------------------------------------------------
        If TC_ResultString <> "" Then
            If ReportType = ReportTypes.ShortReport Then
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " Tonal components" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += GetLastTonalComponentsFromString(TC_ResultString)
            Else
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " Tonal components" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += TC_ResultString
            End If
        End If

        ' ---------------------------------------------------------------------
        '  LAeq SUBTRACT OUTLIERS
        ' ---------------------------------------------------------------------
        LAeq_SubtractedOutliers()
        If LAeqSubtractedOutliers_NotValidPercent > 0 And LAeqSubtractedOutliers_NotValidPercent < 1 Then
            If ReportType = ReportTypes.ShortReport Then
                '
            Else
                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " OUTLIERS" + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += "L'insieme dei dati campionati nel periodo sembra contenere alcuni outliers," + vbCrLf
                Form1.TextBox_Reports.Text += "riconosciuti applicando il metodo della differenza interquartile." + vbCrLf
                Form1.TextBox_Reports.Text += "L'esclusione dei dati apparentemente anomali (circa " + LAeqSubtractedOutliers_NotValidPercent.ToString("0.00000", GCI) + " %)" + vbCrLf
                Form1.TextBox_Reports.Text += "porterebbe ad un differente valore del livello continuo equivalente: " + LAeqSubtractedOutliers.ToString("0.0", GCI) + " dB(A)" + vbCrLf


                ' ---------------------------------------------------------------------
                '  Distributive dB
                ' ---------------------------------------------------------------------

                Form1.TextBox_Reports.Text += vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Form1.TextBox_Reports.Text += " dB DISTRIBUTIVE & CUMULATIVE " + vbCrLf
                Form1.TextBox_Reports.Text += "========================================================" + vbCrLf
                Dim n As Int32 = 0
                For i As Int32 = 0 To 199
                    n += DistributionArray(i)
                Next
                Dim tot As Int32 = 0
                Dim s As String = ""
                For i As Int32 = 0 To 150
                    tot = tot + DistributionArray(i)
                    s += i.ToString.PadRight(8) + _
                                                  (DistributionArray(i) * 100 / n).ToString("0.0").PadRight(8) + _
                                                  (100 - tot * 100 / n).ToString("0.0").PadRight(8) + vbCrLf
                Next
                Form1.TextBox_Reports.Text += s
            End If
        End If

        Form1.TextBox_Reports.Text += vbCrLf
        Form1.TextBox_Reports.Text += "========================================================" + vbCrLf '18/02/2024
        Form1.TextBox_Reports.Text += " LMaxPeakC and Middle Frequency Bands" + vbCrLf                    '18/02/2024
        Form1.TextBox_Reports.Text += "========================================================" + vbCrLf '18/02/2024
        ' ---------------------------------------------------------------- LMaxPeakC                       '18/02/2024
        Form1.TextBox_Reports.Text += "LMaxPeakC = " + LMaxPeakC.ToString("0.0", GCI) + vbCrLf + vbCrLf    '18/02/2024
        ' ---------------------------------------------------------------- Middle Level of Bands Frequency '18/02/2024
        'TODO ------------------------------------
        'If Form1.Chk_Immediate.Checked = True Then
        'CreateMiddleBandValues() '02/03/2024                                                                           '18/02/2024
        Form1.TextBox_Reports.Text += PrintMiddleBandsValues()
        '    Form1.Chk_Immediate.Checked = False
        'End If
        '18/02/2024

        ' ---------------------------------------------------------------------
        '  UPDATE 
        ' ---------------------------------------------------------------------
        Form1.UpdateUserInterface()
        If WriteFile Then
            Form1.SaveReportText(ReportType)
        End If

    End Sub

    Private Function GetLastRowFromString(ByVal s As String) As String
        If s.Length < 3 Then Return s
        Dim n As Int32 = s.LastIndexOf(vbCrLf, s.Length - 2)
        If n < 1 Then Return s
        Return s.Substring(n + 2)
    End Function

    Private Function GetLastTonalComponentsFromString(ByVal s As String) As String
        If s.Length < 3 Then Return s
        Dim n As Int32 = s.LastIndexOf("------------------------------", s.Length - 2)
        If n < 1 Then Return s
        Return s.Substring(n + 2)
    End Function


    ' ===================================================================================================
    '  LAeq SUBTRACT OUTLIERS
    ' ===================================================================================================
    Friend LAeqSubtractedOutliers_Coefficient As Double = 3   ' (k = LAeq_SubtractOutliers)
    Private LAeqSubtractedOutliers As Double = 0
    Private LAeqSubtractedOutliers_NotValidPercent As Double

    Private Sub LAeq_SubtractedOutliers()
        If DataArray1 Is Nothing Then Return
        If DataArray1.GetNumEntries = 0 Then Return
        Dim TotalCounter As Int32 = 0
        Dim ValidCounter As Int32 = 0
        LAeqSubtractedOutliers = 0
        Dim LimitMax As Double = L25tot + LAeqSubtractedOutliers_Coefficient * (L25tot - L75tot)
        Dim LimitMin As Double = L75tot - LAeqSubtractedOutliers_Coefficient * (L25tot - L75tot)
        Dim LAF As Double
        For i As Int32 = 0 To DataArray1.GetNumEntries - 1
            LAF = DataArray1.GetElement(i).LAF
            TotalCounter += 1
            If LAF > LimitMin And LAF < LimitMax Then
                LAeqSubtractedOutliers += 10 ^ (0.1 * LAF)
                ValidCounter += 1
            End If
        Next
        If ValidCounter > 0 Then
            LAeqSubtractedOutliers = 10 * Math.Log10(LAeqSubtractedOutliers / ValidCounter)
        End If
        LAeqSubtractedOutliers_NotValidPercent = 100 - 100 * ValidCounter / TotalCounter
    End Sub

    ' ===================================================================================================
    '  TONAL COMPONENTS
    ' ===================================================================================================
    Private TC_Counter As Int32
    Private TC_StartTime As DateTime
    Private TC_StartTimeWithoutCT As DateTime = DateTime.MinValue
    Private TC_Array(-1) As Double

    Friend TC_MinTimeForStationary_Sec As Int32 = 900
    Friend TC_MaxTimeWithoutCT_Sec As Int32 = 90

    Private TC_ResultString As String

    Private Sub TC_Initialize()
        TC_ResultString = ""
        TC_Counter = 0
        TC_StartTimeWithoutCT = DateTime.MinValue
        ReDim TC_Array(NumBands - 1)
        For i As Int32 = 0 To NumBands - 1
            TC_Array(i) = 99999
        Next
    End Sub

    Private TestFreqCT As Single ' eliminare

    Private Sub TC_CollectComponentsArray()
        Dim FoundComponent As Boolean = False
        For i As Int32 = 1 To NumBands - 2
            If (Array_FastZ(i) - Array_FastZ(i + 1) > 5) And (Array_FastZ(i) - Array_FastZ(i - 1) > 5) Then
                ' -------------------------------------------------------- init
                If TC_Counter = 0 Then
                    TC_StartTime = RowDateTime
                End If
                ' -------------------------------------------------------- add components
                For j As Int32 = 0 To NumBands - 1
                    If Array_FastZ(j) < TC_Array(j) Then
                        TC_Array(j) = Array_FastZ(j)
                    End If
                Next
                TC_Counter += 1
                FoundComponent = True
                TestFreqCT = RoundFreq(Array_CentralBandFreq(i))
            End If
        Next
        ' ---------------------------------------------------------------- test time without CT
        If Not FoundComponent Then
            If TC_StartTimeWithoutCT = DateTime.MinValue Then
                TC_StartTimeWithoutCT = RowDateTime
            Else
                'TODO --------------------------------- aggiungere la condizione if FreqCT_is_changed 06/01/24
                If RowDateTime.Subtract(TC_StartTimeWithoutCT).TotalSeconds > TC_MaxTimeWithoutCT_Sec Then
                    TC_StartTimeWithoutCT = DateTime.MinValue
                    ReDim TC_Array(NumBands - 1)
                    For i As Int32 = 0 To NumBands - 1
                        TC_Array(i) = 99999
                    Next
                    TC_Counter = 0
                    TestFreqCT = TestFreqCT ' eliminare
                End If
            End If
        End If
        ' ---------------------------------------------------------------- TONAL COMPONENTS - test total time 
        StationaryTestInitialize() '06/01/24

        If TC_Counter > 0 Then
            If RowDateTime.Subtract(TC_StartTime).TotalSeconds > TC_MinTimeForStationary_Sec Then ' qui la stazionarietà è valutata come continuità del picco (o con questo codice di un qualsiasi picco) che svetta sulle due bande adiacenti '06/04/24
                'TODO ----------------------------- Inserire il controllo della stazionarietà intesa come LASlow max - LASlow min < 3 dBA
                'If RowDateTime.Subtract(TC_StartTime).TotalSeconds > TC_MinTimeForStationary_Sec And StationaryTest() Then '06/04/24
                TC_Counter = 0
                Find_Tonal_Components()
            End If
        End If
    End Sub

    'TODO ----------------------------------------- Controllo della stazionarietà intesa come LASlow max - LASlow min < 3 dBA  06/01/24
    Private minAS As Single = 999 '06/01/24
    Private maxAS As Single = 0 '06/01/24
    Private InitTestStationariety As Boolean = True '06/01/24
    Private StationarietyTimer As Stopwatch = New Stopwatch '06/01/24

    Private Sub StationaryTestInitialize() '06/01/24
        If InitTestStationariety = True Then
            StationarietyTimer.Reset()
            StationarietyTimer.Start()
            minAS = 999
            maxAS = 0
        End If
    End Sub

    Private Function StationaryTest() As Boolean '06/01/24
        If StationarietyTimer.Elapsed.TotalSeconds() < TC_MinTimeForStationary_Sec Then
            InitTestStationariety = False
            If CSng(Row_LAS) < minAS Then
                minAS = CSng(Row_LAS)
            End If
            If CSng(Row_LAS) > maxAS Then
                maxAS = CSng(Row_LAS)
            End If
            If maxAS - minAS < 3 Then
                Return True
            Else
                Return False
            End If
        Else
            InitTestStationariety = True
        End If
    End Function
    ' ------------------------------------------------------------------------------------------------------

    Friend Sub Find_Tonal_Components()
        '
        Dim Lp, Ln As Double ' Lp= noise level at i-th frequency; Ln=isophonic
        Dim CT As Boolean = False
        Dim CTpenalizable As Boolean
        Dim StringCT As String
        Dim HeaderPrinted As Boolean = False
        '
        For i As Int32 = 1 To NumBands - 3
            If (TC_Array(i) - TC_Array(i + 1) > 5) And (TC_Array(i) - TC_Array(i - 1) > 5) Then
                'StringCT = " CT at " & Array_CentralBandFreq(i) & " Hz" ' 03/01/24
                StringCT = " CT at " & RoundFreq(Array_CentralBandFreq(i)) & " Hz" ' 03/01/24
                ' --------------------------------------------------------------------------------
                ' Deriving loudness level, Ln, from frequency 
                ' (correspond to that af index i) of tonal component, CT
                ' --------------------------------------------------------------------------------
                Ln = LoudnessLevelInterpolated(TC_Array(i), Array_CentralBandFreq(i))
                ' --------------------------------------------------------------------------------
                CTpenalizable = True
                For j As Int32 = 0 To NumBands - 3
                    ' ----------------------------------------------------------------------------
                    '  Deriving sound pressure level from loudness level (iso226 sect 4.1)
                    ' ----------------------------------------------------------------------------
                    Lp = CSng(PressureLevelInterpolated(Ln, Array_CentralBandFreq(i)))
                    ' ----------------------------------------------------------------------------
                    If j <> i And Lp < TC_Array(j) Then
                        CTpenalizable = False
                        Exit For
                    End If
                Next
                ' --------------------------------------------------------------------------------
                If Not HeaderPrinted Then
                    TC_ResultString += "------------------------------ " + RowDateTime.ToString("yyyy/MM/dd HH:mm:ss") + vbCrLf
                    HeaderPrinted = True
                End If
                If CTpenalizable Then
                    TC_ResultString = TC_ResultString + StringCT + " penalizable" + vbCrLf
                Else
                    TC_ResultString = TC_ResultString + StringCT + " NOT penalizable" + vbCrLf
                End If
            End If
        Next
    End Sub

    Friend Function RoundFreq(ByVal f As Single) As Single
        If RoundDisplayFreq Then
            Select Case NumBands
                Case 10, 11
                    For Each rf As Single In Octaves
                        If Math.Abs(rf - f) < f / 100 Then
                            f = rf
                        End If
                    Next
                Case 30, 31, 32, 33, 34
                    For Each rf As Single In ThirdsOctaves
                        If Math.Abs(rf - f) < f / 100 Then
                            f = rf
                        End If
                    Next
                Case Else
                    If f <= 100 Then
                        f = CSng(RoundToNdigits(f, 2))
                    ElseIf f > 100 And f <= 1000 Then
                        f = CSng(RoundToNdigits(f, 2))
                    ElseIf f > 1000 And f <= 10000 Then
                        f = CSng(RoundToNdigits(f, 2))
                    Else
                        f = CSng(RoundToNdigits(f, 3))
                    End If
            End Select
        Else
            ' do nothing
        End If
        Return f
    End Function

    Friend Function RoundToNdigits(ByVal n As Double, ByVal nDigits As Integer) As Double
        ' ----------------------------------------------------- can not calculate log(0)
        If (n = 0) Then Return 0
        ' ----------------------------------------------------- calculate shiftAmount
        Dim numDP As Int32 = CInt(nDigits - Math.Floor(Math.Log10(Math.Abs(n))) - 1)
        Dim shiftAmount As Double = Math.Pow(10, numDP)
        ' ----------------------------------------------------- shift up
        n = n * shiftAmount
        ' ----------------------------------------------------- nearest integer
        n = CInt(n)
        ' ----------------------------------------------------- shift down
        n = n / shiftAmount
        ' ----------------------------------------------------- return
        Return n
    End Function

    Friend Function RoundToNdigits2(ByVal n As Double, _
                                      ByVal nDigits As Integer, _
                                      ByVal nMaxDecimals As Integer, _
                                      ByVal LastSignificativeDigit As Double) As Double
        ' ----------------------------------------------------- can not calculate log(0)
        If (n = 0) Then Return 0
        ' ----------------------------------------------------- limit to last significative digit
        Dim magnitude As Integer = CInt(Floor(Log10(Abs(n)))) - 1
        Dim magnitudeDiff As Integer = CInt(magnitude - Int(Floor(Log10(Abs(LastSignificativeDigit)))))
        If (nDigits > magnitudeDiff) Then
            nDigits = magnitudeDiff
        End If
        ' ----------------------------------------------------- calculate shiftAmount
        Dim numDP As Integer = (nDigits - magnitude)
        If (numDP > nMaxDecimals) Then
            numDP = nMaxDecimals
        End If

        Dim shiftAmount As Double = Pow(10, numDP)
        ' ----------------------------------------------------- shift up
        n = (n * shiftAmount)
        ' ----------------------------------------------------- nearest integer
        If (n > 0) Then
            n = Int(n + 0.5)
        Else
            n = Int(n - 0.5)
        End If
        ' ----------------------------------------------------- shift down
        n /= shiftAmount
        ' ----------------------------------------------------- return
        Return n
        ' n.ToString("0.#", GCI) usare questa per stampare nella stringa
    End Function


    ' =================================================================================================
    ' create mean Frequency spectrum over period if 1 period count (dahy or night) is selected
    ' =================================================================================================

    Friend Function PrintMiddleBandsValues() As String
        Dim str As String = ""
        For i As Int32 = 0 To NumBands - 1
            str += RoundFreq(Array_CentralBandFreq(i)).ToString("0.#", GCI).PadRight(8) + MiddleBandsValues(i).ToString("0.0", GCI) + vbCrLf
        Next
        Return str
    End Function

    ' =================================================================================================
    ' used to launch a webhook
    ' =================================================================================================
    Friend Sub Webhook()
        Dim ProcessProperties As New ProcessStartInfo
        ProcessProperties.FileName = "C:\Program Files\Internet Explorer\IEXPLORE.EXE"
        ProcessProperties.Arguments = "https://webhook.site/26316319-6ed1-40a7-99ba-15e766b4ec7d"
        ProcessProperties.WindowStyle = ProcessWindowStyle.Hidden
        Dim myProcess As Process = Process.Start(ProcessProperties)
        myProcess.WaitForExit(3000)
        If Not myProcess.HasExited Then
            myProcess.Kill()
        End If
    End Sub

End Module
